; Abrec

if (sysmode() <> "Main") then
  Message "The application can only be started from Paradox main mode"
  Sleep 3000
  return
endif

Echo Off
Clear
Reset
Cursor Off


; put up the greeting screen
@ 2, 0
Play "Abrecg"


; ask for the password to the application; this password determines
;   the access to the tables in the application allowed for the
;   current user of the application.

@ 0, 0
Style Attribute SysColor(0)
?? fill(" ",160)
@ 1, 0
?? "Enter password for the application; [Esc] to cancel; [Enter] for no password."
@ 0, 0
?? "Password: "
Cursor Normal
zzzcolor = int(SysColor(0) / 16)
Style Attribute ((zzzcolor * 16) + zzzcolor)
Accept "a50" To pword
Style
EscEnter = not retval
Cursor Off

if (EscEnter) then
  Message "Cancelling the application"
  Sleep 2000
  Clear
  return
endif

if (pword <> "") then
  Password pword
endif


; set up the error proc for the application

ReadLib "Abrecutl" ApplicErrorProc
ErrorProc = "ApplicErrorProc"
ApplicErrorRetVal = FALSE


; Start the application

ReadLib "Abrec1" Abrec1Menu
Abrec1Menu()
Release Procs Abrec1Menu

Clearall
if (pword <> "") then
  UnPassword pword
endif
