; Abrec1



AppLib = "Abrec1"
if (not isfile(AppLib + ".lib")) then
  Createlib AppLib
endif


proc Abrec1S1()
private opResult

  Readlib "Abrecutl" EntryTable, KECheck, ToggleForm,
        EdFldView, HelpKey, EntryCancel, EntryDoIt,
        RenamePre, RenameSet, SaveList, CreateList,
        PrintList

  opResult = EntryTable("Absentee", "", "1", FALSE)

  Release Procs EntryTable, KECheck, ToggleForm,
        EdFldView, HelpKey, EntryCancel, EntryDoIt,
        RenamePre, RenameSet, SaveList, CreateList,
        PrintList

  return opResult
endproc

Writelib AppLib Abrec1S1
Release Procs Abrec1S1

proc Abrec1S3()
private opResult

  if (isempty("Day")) then
    Message "No records to edit"
    Sleep 3000
    return FALSE
  endif

  if (ApplicErrorRetVal) then
    return FALSE
  endif

  Readlib "Abrecutl" EditTable, ToggleForm, EdFldView,
        HelpKey, EditCancel, SEditDoIt

  opResult = EditTable("Day", "Day", "", "1", FALSE,
            "SEditDoIt", "",
            "",
            TRUE, FALSE, FALSE)

  Release Procs EditTable, ToggleForm, EdFldView,
        HelpKey, EditCancel, SEditDoIt


  return opResult
endproc

Writelib AppLib Abrec1S3
Release Procs Abrec1S3

proc Abrec1S4()
private opResult

  Readlib "Abrecutl" EditTable, ToggleForm, EdFldView,
        HelpKey, EditCancel, SEditDoIt, SEditDelIns

  opResult = EditTable("Hisreqst", "Hisreqst", "", "1", FALSE,
            "SEditDoIt", "SEditDelIns",
            "[Ins] - Insert a record, [Del] - Delete a record",
            FALSE, FALSE, FALSE)

  Release Procs EditTable, ToggleForm, EdFldView,
        HelpKey, EditCancel, SEditDoIt, SEditDelIns


  return opResult
endproc

Writelib AppLib Abrec1S4
Release Procs Abrec1S4

proc Abrec1S5()
private opResult

  if (isempty("Absentee")) then
    Message "No records to edit"
    Sleep 3000
    return FALSE
  endif

  if (ApplicErrorRetVal) then
    return FALSE
  endif

  Readlib "Abrecutl" EditTable, ToggleForm, EdFldView,
        HelpKey, EditCancel, SEditDoIt, SEditDelNoIns

  opResult = EditTable("Absentee", "Absentee", "", "2", FALSE,
            "SEditDoIt", "SEditDelNoIns",
            "[Del] - Delete a record",
            TRUE, FALSE, FALSE)

  Release Procs EditTable, ToggleForm, EdFldView,
        HelpKey, EditCancel, SEditDoIt, SEditDelNoIns


  return opResult
endproc

Writelib AppLib Abrec1S5
Release Procs Abrec1S5

proc Abrec1S6()
private opResult

  Readlib "Abrecutl" EditTable, ToggleForm, EdFldView,
        HelpKey, EditCancel, SEditDoIt, SEditDelIns

  opResult = EditTable("Termnate", "Termnate", "", "1", FALSE,
            "SEditDoIt", "SEditDelIns",
            "[Ins] - Insert a record, [Del] - Delete a record",
            FALSE, FALSE, FALSE)

  Release Procs EditTable, ToggleForm, EdFldView,
        HelpKey, EditCancel, SEditDoIt, SEditDelIns


  return opResult
endproc

Writelib AppLib Abrec1S6
Release Procs Abrec1S6

proc Abrec1Menu()
private x, escape, zzzmexit, zzzzexit, pword

  zzzzexit = FALSE
  x = "Absences"
  while (TRUE)
    Clear

    ShowMenu
        "Absences": "Enter new absence and tardy data",
        "Reports": "Reprimand, Absentee History, Code & Value Summary",
        "DateStamp": "Set current dates for new absence and tardy data",
        "History": "Specify individuals for Absentee History Report",
        "Edit": "Edit existing absence and tardy data",
        "Terminate": "Purge all absence and tardy data for individuals",
        "Calc": "Calculate violations, purge terminations, queue histories",
        "Policy": "Set enforcement period, violation values, reprimand policy",
        "Quit": "Exit the Absentee Records program"
      Default x
      To x

    switch
      case x = "Absences":
        ReadLib "Abrec1" Abrec1S1
        escape = Abrec1S1()
        escape = not escape
        Release Procs Abrec1S1

      case x = "Reports":
        ReadLib "Abrec1" Abrec2Menu
        escape = Abrec2Menu()
        escape = not escape
        Release Procs Abrec2Menu

      case x = "DateStamp":
        ReadLib "Abrec1" Abrec1S3
        escape = Abrec1S3()
        escape = not escape
        Release Procs Abrec1S3

      case x = "History":
        ReadLib "Abrec1" Abrec1S4
        escape = Abrec1S4()
        escape = not escape
        Release Procs Abrec1S4

      case x = "Edit":
        ReadLib "Abrec1" Abrec1S5
        escape = Abrec1S5()
        escape = not escape
        Release Procs Abrec1S5

      case x = "Terminate":
        ReadLib "Abrec1" Abrec1S6
        escape = Abrec1S6()
        escape = not escape
        Release Procs Abrec1S6

      case x = "Calc":
        Play "Calc"
        x = "Calc"
        escape = FALSE

      case x = "Policy":
        ReadLib "Abrec1" Abrec3Menu
        escape = Abrec3Menu()
        escape = not escape
        Release Procs Abrec3Menu

      case x = "Quit":
        ShowMenu
            "No": "Do not exit the program",
            "Yes": "Leave the program"
          To zzzmexit

        zzzzexit = (zzzmexit = "Yes")
        escape = (zzzmexit = "Esc")

      case x = "Esc":
        escape = FALSE
    endswitch

    Reset
    ; reset ErrorProc value
    ErrorProc = "ApplicErrorProc"
    ApplicErrorRetVal = FALSE

    if (zzzzexit) then
      return TRUE
    endif

    if (not escape) then
      x = "Absences"
    endif
  endwhile
endproc

Writelib AppLib Abrec1Menu
Release Procs Abrec1Menu

