****************************************************************************
* DBE_05.PRG
*
* CALLED FROM DBE_DEMO.PRG
*
* Demonstrates the use of the fields array as the 5th parameter of DBEDIT()
* Adds the header array.
* Skips the UDF and Picture parameters.
*
*  FUNCTION     SOURCE
*  ===========  ==============
*  SHADOW()     DBE_UDF.PRG
*  MILDATE()    DBE_UDF.PRG
*  DBEDIT()     EXTEND.LIB
*
*
*  NOTE:
*
*  Let's skip the UDF and PICTURE arrays for a moment and add headings
*  that will be more meaningful for our users.  "LAST DATE" is friendlier
*  than "MILDATE(LAST_DATE)"!  All we need to do is DECLARE a heading array
*  and fill the array elements with the corresponding headings.
*
*  Notice that you have to pass dummy parameters for the parameters that
*  we skip!  I chose to just pass ".f." as dummy parameters.
*
*****************************************************************************
USE PEOPLE
DECLARE a_field[3], a_hdr[3]
a_field[1]="NAME"
a_hdr[1]  ="NAME"
a_field[2]="RANK"
a_hdr[2]  ="RANK"
a_field[3]="MILDATE(LAST_EXAM)"
a_hdr[3]  ="LAST EXAM"
@ 23, 1 SAY "<Esc>=Exit    <Enter>=Select"
SHADOW( 4, 4, 19, 76, "N+/W")
@ 6, 4 SAY CHR(204)
@ 6,76 SAY CHR(185)
DBEDIT( 5, 5, 18, 75, a_field, .f., .f., a_hdr)
RETURN
*<EOF: DBE_05.PRG *-------------------------------------------------------*


