****************************************************************************
* DBE_06.PRG
*
* CALLED FROM DBE_DEMO.PRG
*
* Demonstrates the use of the fields array as the 5th parameter of DBEDIT()
* Adds the header array.
* Skips the UDF and Picture parameters.
*
* Displays fields from 2 databases related by workplace I.D. 
*
*  FUNCTION     SOURCE
*  ===========  ==============
*  SHADOW()     DBE_UDF.PRG
*  DBEDIT()     EXTEND.LIB
*
*
*  NOTE:
*
*  We are not limited to a single data file!  We can display multiple
*  data files through the use of the SET RELATION TO and by including the
*  FILENAME-> prefix to each field's name.
*
*  I also added another nice touch by adding the ASCII characters to
*  connect the double and single lines of the column separators.  
*  Parameters #9 and #11 handle this chore for us.
*
*
*****************************************************************************
SELECT 0
USE SHOP INDEX SHOPWPID
SELECT 0
USE PEOPLE
SET RELATION TO WPID INTO SHOP
DECLARE a_field[3], a_hdr[3]

a_field[1]="PEOPLE->NAME"
a_hdr[1]  ="NAME"
a_field[2]="PEOPLE->RANK"
a_hdr[2]  ="RANK"
a_field[3]="SHOP->SHOP"
a_hdr[3]  ="SHOP"

m_hdr_sep= CHR(205)+CHR(209)+CHR(205)
m_ftr_sep= CHR(205)+CHR(207)+CHR(205)
@ 23, 1 SAY "<Esc>=Exit    <Enter>=Select"
SHADOW( 4, 4, 19, 76, "N+/W")
@ 6, 4 SAY CHR(204)
@ 6,76 SAY CHR(185)
DBEDIT( 5, 5, 19, 75, a_field, .f., .f., a_hdr, m_hdr_sep,.F., m_ftr_sep )
*       1  2   3   4     5      6    7     8        9      10      11      
RETURN
*<EOF: DBE_06.PRG *-------------------------------------------------------*


