*******************************************************************************
* Program.....:  DBE_DEMO.PRG
* Written by..:  Robert L. Williams
*
* E-MAIL......:  CompuServe:  73537,3431
*                DDN.......:  1LESGPM@TACHOST.AF.MIL
*                OEHL EIES.:  LANGSGPMA or ASIMS
*
* Date........:  June 3, 1990
* Purpose.....:  Demonstrate the DBEDIT() function of Clipper (Summer '87)
*
* Data Files..:  PEOPLE.DBF    Created in DBE_FILE.PRG
*                SHOP.DBF      Created in DBE_FILE.PRG
*                DBE_DEMO.DBF  Created in DBE_FILE.PRG
*              
******************************************************************************
PARAMETER mcolor   && Allows me to force monochrome on color computers

IF PCOUNT() = 1
  mcolor= UPPER( mcolor )
ELSE
  mcolor= IF( ISCOLOR(), "C", "M" )
ENDIF
SET PROCEDURE TO DBE_UDF
SET PROCEDURE TO DBE_FILE
SET PROCEDURE TO DBE_CNST
SET PROCEDURE TO DBE_01
SET PROCEDURE TO DBE_02
SET PROCEDURE TO DBE_03
SET PROCEDURE TO DBE_04
SET PROCEDURE TO DBE_05
SET PROCEDURE TO DBE_06
SET PROCEDURE TO DBE_07
SET PROCEDURE TO DBE_08
SET PROCEDURE TO DBE_09
SET PROCEDURE TO DBE_10
SET CURSOR OFF
SET SCOREBOARD OFF

normal= "W+/B,GR+/N,,,W/N"
red=    "W+/R"
gray=   "N+/W"

* #include <dbe_cnst.prg> (to initialize constants)
DO DBE_CNST

COLOR( normal )
CLEAR SCREEN
@ 1, 1 SAY "DBEDIT() DEMONSTRATION PROGRAM"
@ 2, 0 TO 2, 79 DOUBLE
@ 22, 0 TO 22, 79
SAVE SCREEN TO mainscrn
DO DBE_FILE

DECLARE menufield[2], menuhdr[2]
menufield[1]= "FILENAME"
menufield[2]= "DESCRIP"
menuhdr[1]= "FILE"
menuhdr[2]= "DEMONSTRATION"
menu_fsep= CHR(205)+CHR(207)+CHR(205)
last_pick= 0
DO WHILE .T.
  COLOR( normal )
  RESTORE SCREEN FROM mainscrn
  @ 23, 1 SAY "Use cursor keys and press <Enter> to select a demonstration."
  @ 24, 1 SAY "Press <Esc> to return to MS-DOS."
  SHADOW( 4, 4, 19, 75, "W+/R")   
  @  6, 4 SAY CHR(204)
  @  6,75 SAY CHR(185)
  USE DBE_DEMO
  CLEAR TYPEAHEAD
*.. Move the highlight bar over to the description field:
  curs_mov= CHR( RT_ARROW )
*.. Move down to the next pick
  IF last_pick > 0
    FOR kpress= 1 TO last_pick 
      curs_mov= curs_mov + CHR( DOWN_ARROW )
    NEXT
  ENDIF
  KEYBOARD curs_mov
  DBEDIT( 5, 5, 19, 74, menufield, .f., .f., menuhdr, .f., .f., menu_fsep)
  IF LASTKEY() = 27
    EXIT
  ENDIF
  COLOR( normal )
  @ 3, 0 CLEAR TO 21, 79
  @ 1, 0 
  @ 1, 1 SAY FILENAME + "   " + DESCRIP
  @ 23, 0 CLEAR
  sFile= TRIM(FILENAME)
  sProc= TRIM(DEMOPROC)
  is_demo= ! EMPTY( DEMOPROC )
  last_pick= RECNO()
  CLOSE
  SHOWTEXT( sFile,  is_demo )
  IF LASTKEY() = -9 .AND. is_demo
    DO &sProc
  ENDIF
  CLOSE DATA
ENDDO
SET CURSOR ON
SET COLOR TO
CLEAR 
QUIT
* <EOF:  DBE_DEMO.PRG> ------------------------------------------------------*

