*	DBTPULDN.PRG - Pulldown Menu System Demo
*   (c) 1990    BERNATH COMPUTER    V 1.23S
*   07/21/1990

CALL DBTOOLS WITH "15,3"
HCHOICE = 1
EXITNOW = .f.
CALL DBTOOLS WITH "7,2,0,7,0"
CALL DBTOOLS WITH "5,0,0,0,79,1"
CALL DBTOOLS WITH "1,0,20,15,1,0,PULLDOWN MENU SYSTEM DEMONSTRATION"
CALL DBTOOLS WITH "3,13,1,22,77,1,3,2,0,1"
set color to b/bg,+bg/n,w
@ 14,2 say "This is example of a pulldown menu system using dBTools. The horizontal"
@ 15,2 say "bar menu options may be selected with arrow keys or 1st letter keystrokes"
@ 16,2 say "to pull down the underlying vertical bar menus. Once a vertical menu is"
@ 17,2 say "showing, an adjacent vertical menu may be selected with the left and right"
@ 18,2 say "arrow keys. Alternatively, pressing the hotkey combination indicated on the"
@ 19,2 say "horizontal menu will jump right into that vertical menu. Inside a vertical"
@ 20,2 say "menu, up and down arrow keys or 1st letter select the vertical option. ESC"
@ 21,2 say "pops you back up to the horizontal menu."
set color to w/b
do while .not. EXITNOW
 
   mMENUSTR="9,"+str(HCHOICE,2)+",2,2,7,0,0,7,  Data Entry (^D)  ;
   ,  Reports (^R)  ,  Utilities (^U)  ,  Quit (^Q)  ,@"
   call dbtools with mMENUSTR
   HCHOICE = val(mMENUSTR)
   do case
       case HCHOICE = 0                         && ESC
           EXITNOW = .t.

       case HCHOICE =1                          && DATA ENTRY
         VCHOICE = 1
         do while VCHOICE <> 0
            call dbtools with "21,3,3,2,7,23,0,7,1,1"
            mPARM="20,Y,"+str(VCHOICE,2)+",3,15,0,2,Scancodes,2. Opt 2,3. Opt 3,@"
            call dbtools with mPARM
            VCHOICE = val(mPARM)
            do case
               case VCHOICE = 0                 && ESC
               case VCHOICE = 1
               	   do SHOW_SCAN
               case VCHOICE = 99
                   do TRAPIT with mPARM,HCHOICE,4,"HKPULDN"
                   call dbtools with "19,3"
                   exit
               otherwise
                  do popped with VCHOICE,"Data Entry"
            endcase
            call dbtools with "19,3"
         enddo

       case HCHOICE = 2                         && REPORTS
         VCHOICE = 1
         do while VCHOICE<>0
            call dbtools with "21,3,3,24,7,41,11,1,1,1"
            mPARM="20,Y,"+str(VCHOICE,2)+",3,1,3,2,First Option,Second Option,Third Option,@"
            call dbtools with mPARM
            VCHOICE = val(mPARM)
            do case
               case VCHOICE = 0
               case VCHOICE = 99
                   do TRAPIT with mPARM,HCHOICE,4,"HKPULDN"
                   call dbtools with "19,3"
                   exit
               otherwise
                   do popped with VCHOICE,"Reports"
            endcase
            call dbtools with "19,3"
         enddo

       case HCHOICE = 3                         && UTILITIES
         VCHOICE = 1
         do while VCHOICE <> 0
            call dbtools with "21,3,3,42,7,61,15,5,1,1"
            mPARM="20,Y,"+str(VCHOICE,2)+",3,12,0,2,First Option,Second Option,Third Option,@"
            call dbtools with mPARM
            VCHOICE = val(mPARM)
            do case
                case VCHOICE = 0
                case VCHOICE = 99
                   do TRAPIT with mPARM,HCHOICE,4,"HKPULDN"
                   call dbtools with "19,3"
                   exit
                otherwise
                   do popped with VCHOICE,"Utilities"
            endcase
            call dbtools with "19,3"
         enddo

       case HCHOICE = 4                         && QUIT

            call dbtools with "21,3,3,62,6,76,7,4,1,1"
            VCHOICE = 1
            mPARM="20,Y,"+str(VCHOICE,2)+",3,15,0,1,Main Menu,Dot Prompt,@"
            call dbtools with mPARM
            VCHOICE = val(mPARM)
            do case
                case VCHOICE = 1
                    EXITNOW = .T.
                case VCHOICE = 2
                    call dbtools with "19,3"
                    clear
                    cancel
                case VCHOICE = 99
                   do TRAPIT with mPARM,HCHOICE,4,"HKPULDN"
            endcase
            call dbtools with "19,3"
   endcase
enddo

EXITNOW=.f.
CALL DBTOOLS WITH "14,3,0"
return
