echo off
cls
REM Installation program for R&R Report Writer Demonstration
REM (C) 1991 Copyright Show & Tell, Inc.  
break=on
batchman window 1, 1, 80, 25, 0Fh,-
batchman window 3, 7, 70, 3, 1Fh
batchman window 3, 7, 9, 3, 4Fh
batchman setcursor 4,8
batchman cecho, C   R&R 
batchman setcursor 4, 17
batchman cecho, C Report Writer Demonstration Installation  
batchman setcursor 8, 17
batchman cecho, C This procedure creates a subdirectory named RRDEMO on 
batchman setcursor 9, 17
batchman cecho, C your hard disk and copies the demonstration files     
batchman setcursor 10, 17
batchman cecho, C into that subdirectory.
batchman setcursor 12, 17
batchman cecho, C The demo requires approximately 600 KB of disk space.
batchman setcursor 16, 17
batchman cecho, C Would you like to install the demonstration? (Y or N) [ ]
batchman setcursor 24, 20
batchman cecho, C Press [CONTROL-BREAK] to Exit Installation
batchman setcursor 16, 72
batchman getkey 'yn'
IF ERRORLEVEL 2 goto NOINST
IF ERRORLEVEL 1 goto DRIVE
goto end

:NOINST
batchman cecho, C N
goto end

:drive
batchman cecho, C Y
batchman setcursor 18, 16
batchman cecho, C  Which disk drive would you like to copy the demo to? [ ]
batchman setcursor 19, 16
batchman cecho, C             (Please enter a drive C through F)
batchman setcursor 18, 71
batchman getkey 'cdef'
IF ERRORLEVEL 5 goto end
IF ERRORLEVEL 4 goto installf
IF ERRORLEVEL 3 goto installe
IF ERRORLEVEL 2 goto installd
IF ERRORLEVEL 1 goto installc
IF ERRORLEVEL 0 goto end
goto END

:old
if x%1==x  goto :error
if x%2==x  goto :error

:installc
batchman cecho, C C
batchman driveexist c:
IF ERRORLEVEL 1 goto nextc
IF ERRORLEVEL 0 goto NoDrive
goto nextc
:nextc
free c: 600000      
IF ERRORLEVEL 1 goto NoSpace
batchman window  7, 15, 60, 15, 0Fh
batchman setcursor 13, 17
batchman cecho, C Installing the R&R Report Writer demo on C:\RRDEMO...
batchman setcursor 24, 19
batchman cecho, C Press [CONTROL-BREAK] to cancel installation.
batchman setcursor 25,1
batchman direxist c:\RRDEMO
IF ERRORLEVEL 1 goto copyc
md C:\RRDEMO >nul
goto copyc
:copyc
RRDEMO$ -o C:\RRDEMO >NUL
c:
cd \RRDEMO
goto FINISH
if errorlevel 1 goto :end
goto end

:installd
batchman cecho, C D
batchman driveexist d:
IF ERRORLEVEL 1 goto nextd
IF ERRORLEVEL 0 goto NoDrive
goto nextd
:nextd
free d: 600000  
IF ERRORLEVEL 1 goto NoSpace
batchman window  7, 15, 60, 15, 0Fh
batchman setcursor 13, 17
batchman cecho, C Installing the R&R Report Writer demo on D:\RRDEMO...
batchman setcursor 24, 19
batchman cecho, C Press [CONTROL-BREAK] to cancel installation.
batchman setcursor 25,1
batchman direxist d:\RRDEMO
IF ERRORLEVEL 1 goto copyd
md D:\RRDEMO >nul
goto copyd
:copyd
RRDEMO$ -o D:\RRDEMO >NUL
d:
cd \RRDEMO
goto FINISH
if errorlevel 1 goto :end
goto end

:installe
batchman cecho, C E
batchman driveexist e:
IF ERRORLEVEL 1 goto nexte
IF ERRORLEVEL 0 goto NoDrive
goto nexte
:nexte
free e: 600000                      
IF ERRORLEVEL 1 goto NoSpace
batchman window  7, 15, 60, 15, 0Fh
batchman setcursor 13, 17
batchman cecho, C Installing the R&R Report Writer demo on E:\RRDEMO
batchman setcursor 24, 19
batchman cecho, C Press [CONTROL-BREAK] to cancel installation.
batchman setcursor 25,1
batchman direxist e:\RRDEMO
IF ERRORLEVEL 1 goto copye
md E:\RRDEMO >nul
goto copye
:copye
RRDEMO$ -o E:\RRDEMO >NUL
e:
cd \RRDEMO
goto FINISH
if errorlevel 1 goto :end
goto end


:installf
batchman cecho, C F
batchman driveexist f:
IF ERRORLEVEL 1 goto nextf
IF ERRORLEVEL 0 goto NoDrive
goto nextf
:nextf
free f: 600000                      
IF ERRORLEVEL 1 goto NoSpace
batchman window  7, 15, 60, 15, 0Fh
batchman setcursor 13, 17
batchman cecho, C Installing the R&R Report Writer demo on F:\RRDEMO...
batchman setcursor 24, 19
batchman cecho, C Press [CONTROL-BREAK] to cancel installation.
batchman setcursor 25,1
batchman direxist f:\RRDEMO
IF ERRORLEVEL 1 goto copyf
md F:\RRDEMO >nul
goto copyf
:copyf
RRDEMO$ -o F:\RRDEMO >NUL
f:
cd \RRDEMO
goto FINISH
if errorlevel 1 goto :end
goto end

:nodrive
batchman window 7, 15, 60, 17, 0Fh
batchman setcursor 14, 22
batchman cecho, C The specified disk drive does not exist!
batchman setcursor 15, 17
batchman cecho, C Please try installing the demo on an existing drive.
batchman setcursor 24, 20
batchman cecho, C       Press [ESCAPE] to return to DOS...                 
batchman setcursor 24, 40
batchman getkey
IF ERRORLEVEL 1 goto end
goto end

:noinstall
batchman window 7, 15, 60, 17, 0Fh
batchman setcursor 14, 15
batchman cecho, C The INSTALL program does not work for the specified drive!
batchman setcursor 15, 24
batchman cecho, C Please try installing the demo on Drives C-F.
batchman setcursor 24, 20
batchman cecho, C       Press [ESCAPE] to return to DOS...                      
batchman setcursor 24, 40
batchman getkey
IF ERRORLEVEL 1 goto end
goto end

:nospace
batchman window 7, 15, 60, 17, 0Fh
batchman setcursor 14, 25
batchman cecho,   You do not have enough diskspace!
batchman setcursor 15, 24
batchman cecho,   You need 600 KB to install the demo.
batchman setcursor 24, 20
batchman cecho, C       Press [ESCAPE] to return to DOS...            
batchman setcursor 24, 40
batchman getkey
IF ERRORLEVEL 1 goto end
goto end

:FINISH
cls
echo 
echo                             Installation completed.                         
echo 
echo        To run the R&R Report Writer demonstration type DEMO then [RETURN].
echo 
goto DONE

:END
cls

:DONE
