****************************************************************************
*                                                                          *
* PROGRAMMER:      R. Scott Mackay                                         *
*                                                                          *
* DESCRIPTION:     Header/Footer Library DEMO - See HeadFoot.Txt for       *
*                  more information.                                       *                                                                          *
*                                                                          *
****************************************************************************
SET LIBRARY TO HEADFOOT ADDITIVE
SET CURSOR OFF

DEFINE WINDOW TEMP FROM 7,4 TO 22,76 COLOR SCHEME 10 SYSTEM SHADOW
ACTIVATE WINDOW TEMP


***** Opening Message *****
=SAYFOOT("Descriptions can be printed here -- and will be during this demo.",0)
WAIT WINDOW "Press Any Key"
=SAYFOOT("")

***** Give window a title *****
=SAYFOOT("Now let's give this window a title.",0)
WAIT WINDOW "Press Any Key"
=SAYHEAD("Branch Report")
=SAYFOOT("Notice that the title is centered, this is the default.",0)
WAIT WINDOW "Press Any Key"

***** Print on the header without clearing the title *****
=SAYFOOT("Now without clearing the title we can print other messages.",0)
WAIT WINDOW "Press Any Key"
=SAYHEAD("23 Records Found",0)
=SAYFOOT("Notice that the title is still in place.                   ",0)
WAIT WINDOW "Press Any Key"

***** Print on the header right aligned *****
=SAYFOOT("We can print right-aligned on the header without clearing the title.",0)
WAIT WINDOW "Press Any Key"
=SAYHEAD("Updating",80)

***** Print on the header right aligned -- and clear old title *****
=SAYFOOT("")
=SAYFOOT("We can also print a new title so that it is right-aligned",0)
WAIT WINDOW "Press Any Key"
=SAYHEAD("")
=SAYHEAD("Right-Aligned Title",80)

***** Print on the header right aligned -- and clear old title *****
=SAYFOOT("All of these features are available for printing on the footer as well.",0)
WAIT WINDOW "Press Any Key"

=SAYHEAD("Header/Footer Library Demo")
=SAYFOOT("")
=SAYFOOT("This concludes the Demo of the Header/Footer Library  ",0)
WAIT WINDOW "Press Any Key"
RELEASE WINDOW TEMP
