



***********************************************************************
* Flow charts Dbase III+ routines and puts list on screen or printer.
***********************************************************************




***********************************************************************
*
*   Written by Dennis Unger 11/26/91
*   Copyright @1991 by Unger & Associates
*
*  Legal Stuff:
*       This program is being distributed as shareware, however the
*       this program is COPYRIGHTED, which means if you use this program
*       on a regular basis, then you are obligated to register this program!
*
*       To register, send $5.00 to:
*               Unger & Associates
*               P.O. Box 836
*               Goldenrod, Fl. 32733
*
*
*  Overview:
*       This program when given the starting program's name, in a
*       multi-program system, will trace through modules and
*       print (to screen or printer) the sub-modules called from
*       each module.
*
*  Notes:
*
*       1 - Note that 3 database's are used and must be in
*           the directory in use, path.dbf, lines.dbf, temp.dbf.
*
*       2 - Procedure files... Unless you have seperate files
*           on the disk for each procedure in the file, this
*           program will crash. A simple way around this is
*           to make sure that a TAB is the first character on
*           the line which has the DO that calls a module in
*           the procedure file.
*
*       3 - Note that program searches a line for a DO, then
*           elimatiates DO While, DO Case . The first printiable
*           character on a line is used for the DO search... so
*           if you DO NOT want to trace a module put a TAB as
*           the first character on the line, and the module will
*           not be searched.
*
*
**********************************************************************




clear all
set escape off
set talk off
set safety off
filename = space(8)
clear

set color to r+/g+,b/gr,b
@ 0,0 to 8,79 double
set color to n+/g+,b/gr,b
@ 2,20 say "Flow Charter For dBase 3+"
@ 3,20 say "Copyright @1991 By Unger & Associates"
@ 4,20 say "P.O. Box 836"
@ 5,20 say "Goldenrod, Fl. 32733"
@ 6,20 say "Shareware Version."
set color to gr+/g+,b/gr,b

	@ 10,10 say "Enter program to analyze" get filename
	read
	output ="s"

	set color to b/g+,b/gr,b
	@ 12,10 say " Send output to (S)creen or (P)rinter (S/P) " get output picture "!"
	read

	filename =trim(filename)+".prg"

	if lower(output) ="p"
		set device to print
		@ 1,5 say "***********************************************************"
		@ 2,5 say "*         Printout From dBase 3 Plus Flow Charter         *"
		@ 3,5 say "*         Copyright @1991 By Unger & Associates           *"
		@ 4,5 say "***********************************************************"
		@ 6,5 say "Name Of Starting File: " + filename +".prg"
		@ 7,5 say "Printed  On  " + dtoc(date())
		@ 8,5 say "Time Printed " + time()
		set device to screen
		set print on
		?
		?

	endif

	use lines
	zap
	select 2
	use path
	zap
	select 1
	append from &filename SDF
	replace all line with upper(ltrim(line))
	set filter to line = "DO " .and..not.("WHILE"$line.or."CASE"$line)
	go top

	?"Subs in "+filename

	do while .not. eof()
		? "Sub Routine " + substr(line,4,9)+ "called from "+ filename

		select 2
		append blank
		replace routine with substr(lines->line,4,9)

		replace calledfrom with upper(substr(filename,1,at(".",filename)-1))
		select 1
		skip
	enddo

	set deleted on
	select 2

	do while .t.
		count to morefiles

			if morefiles = 0
				exit
			endif

		copy structure to temp
		select 3
		use temp
		select 2
		go top

		do while .not. eof()
			filename =trim(routine)+ ".prg"
			select 1
			use lines
			zap
			append from &filename SDF
			replace all line with upper(ltrim(line))
			set filter to line = "DO "  .and..not.("WHILE"$line.or."CASE"$line)
			go top
			?
			? "--------------------------------------------------------------------"
			?"Sub Routines Contained In Program "+filename

			do while .not.eof()
				?"Sub Routine "+substr(line,4,9)+" Called from "+filename
				select 3
				append blank
				replace routine with substr(lines->line,4,9)
				replace calledfrom with upper(substr(filename,1,at(".",filename)-1))
				select 1
				skip
			enddo

			select 2
			delete
			skip

		enddo

		select 3
		use
		select 2
		append from temp

	enddo

	if lower(output)="p"
		?
		?
		? "     *******************"
		? "     *  End Of Report  *"
		? "     *******************"
		?
		set print off
		eject
	endif

	select 2
	recall all
	set deleted off
	set talk on
	set safety on
	set escape on


