SET BELL OFF
SET TALK OFF
SET ESCA OFF
SET SAFE OFF
SET STAT OFF
SET SCOR OFF          && IMPORTANT!!! Titles are on the top line

LOAD FASTMENU

TNORMFG = 7
TNORMBG = 3
TREVFG = 0
TREVBG = 3
STORE .F. TO TNORMBLNK, TREVHIGH, TREVBLNK
TNORMHIGH = .T.

MNORMFG = 7
MNORMBG = 3
MREVFG = 0
MREVBG = 3
STORE .F. TO MNORMBLNK, MREVHIGH, MREVBLNK
MNORMHIGH = .T.

mFALSE = '0'
mTRUE  = '1'

DEF_MENU   = ' '          && use default menu
DEF_LINE   = ' '          && use default line
***********************************************************************
* options for fastmenu bits (FMBITS) are as follows:
*     bit 0 - (1)  on if escape to exit is valid
*         1 - (2)  on if escape from menus to show titles only is valid
*         2 - (4)  on for titles only (off to use previous status)
*         3 - (8)  on if clock should be shown in corner
*         4 - (16) on if screen should be restored on exit
***********************************************************************
mFMNAME  = 'ASSIST'
mFMRELOAD = .T.             && to see if we need to reload pull down menus

COLOR = ''

DO WHILE .T.
  SET COLOR TO W+/B,W/N,B
  CLEAR
  @ 1,0 TO 24,79 DOUBLE
  @ 24,06 SAY ' Test Program for FASTMENU (tm) - Bowen Software (c) 1989-90 '

  IF LEN(TRIM(COLOR)) <> 0
    @ 22,10 SAY 'To use these colors call FASTMENU with: '+COLOR
  ENDIF
  COLOR = ''
  IF mFMRELOAD
    mFMRELOAD = .F.
    DEF_MENU = 'A'
    DEF_LINE = 'A'
    FMBITS   =  26            && in binary 0001 1010 (0x1E)
    IF mFMNAME = 'ASSIST'
      FMBITS = FMBITS + 16    && menus stay on the screen
    ENDIF
    DO FMLOAD WITH mFMNAME
  ELSE
    DEF_MENU = ' '
    DEF_LINE = ' '
  ENDIF
  mEXEC = 'E' + DEF_MENU + DEF_LINE + CHR(FMBITS)
  CALL FASTMENU WITH mEXEC

* Now parse the passed variable to get operator selection
  mMENU = SUBS(mEXEC,1,1)       && returns first position with menu
  mSEL = SUBS(mEXEC,2,1)        && second position with selection (line)
  mFATAL = SUBS(mEXEC,3,1)      && third position with error, if there is one
  mESC = SUBS(mEXEC,4,1)        && fourth position with ESC status

  IF mFATAL <> '0'
    ?? CHR(7)
    mMSG = ''
    DO FMERROR WITH mFATAL, mMSG
    ? 'System Error: Call Bowen Software 1-309-699-0950'
    ? mMSG
    mKEY = 0
    DO WHILE mKEY = 0
      mKEY = INKEY()
    ENDDO
    EXIT
  ENDIF

  * Now process the menu selection
  DO CASE
  CASE mFMNAME = 'ASSIST'

    DO CASE
    CASE mMENU = 'A'
      DO CASE
      CASE mSEL = 'F'
        EXIT
      CASE mSEL = 'G'
        DO FMCOLOR WITH COLOR
      CASE mSEL = 'H'
        mFMNAME = 'POMAIN'
        mFMRELOAD = .T.
      ENDCASE
    CASE mMENU = 'B'
    CASE mMENU = 'C'	&& etc...
    ENDCASE

  CASE mFMNAME = 'POMAIN'     && different menu system

    DO CASE
    CASE mMENU = 'A'
      DO CASE
      CASE mSEL = 'G'
        mFMNAME = 'ASSIST'
        mFMRELOAD = .T.
      ENDCASE
    CASE mMENU = 'B'
    CASE mMENU = 'C'
    CASE mMENU = 'D'
      EXIT
    ENDCASE

  ENDCASE

ENDDO

RELEASE FASTMENU

DO CASE
  CASE mSEL = 'B'
    QUIT             && exit to DOS
  CASE mSEL = 'C'
    ASSIST           && exit to ASSIST
ENDCASE
CLEAR
RETURN