***************************************************************************
*** Matchup.prg (c) 1992 Steve Ramsower - RamPower Systems (tm)			***
*** (619) 562-9370														***
*** Distributed as shareware, not "Freeware".							***
*** This program is Not in the public domain.							***
***																		***
*** Feel free to copy and distribute this program freely.				***
*** You may also include it in your own applications as long as you		***
*** conform with the following:											***
*** 																	***
*** 	- Do not remove the copyright notice or RamPower name or 		***
***		  phone number from the screen as presented to the user.		***
*** 																	***
***	If find this program of value to yourself or include it in any		***	
*** work done for hire or sale, please register it by sending 			***	
*** your name, address, and phone number along with a payment of $20.00	***
***	for each copy to:	Steve Ramsower									***
***						RamPower Systems								***
***						10007 Burrock Drive								***
***						Santee, CA 92071-1128							***
***																		***
*** RamPower Systems specializes in custom business systems developed	***
*** in FoxPro with an emphasis on retail and inventory operations that	***
*** utilize bar coding. We also couple these front end systems with our ***
*** General Ledger and Accounts Payable system.							***
*** 																	***
*** There are several benefits to including a game such as Matchup in a	***
*** serious	application:												***
*** 	- 	Many users of our systems are new to computing. A game like	***
***			Matchup is simple to master and the rules of the game are	***
***			already know to most people. 								***
***		-	It provides the new user with a rewarding experience with	***
***			the computer early on. This can help to reduce the fear and	***
***			denial or rejection of computers that many new users feel.	***
***		-	The use of the keyboard and mouse provide good practice for	***
***			techniques used in navigating around the FoxPro user inter-	***
***			face. Again helping to develop skills that will aid in the	***
***			acceptance of your product.									***
***																		***
***			Enjoy Matchup, good luck, and may God Bless you and yours.	***
*** 																	***
***											Thank You,  Steve Ramsower	***
*** 																	***
***************************************************************************
set talk off
matconf=set("confirm")
matbel=set("bell")
matsmenu=set("sysmenu")
if ! "2."$vers()
	clear
	wait "Sorry, Matchup only runs in FoxPro Version 2.0 or later." 
	return
endif

set bell off
set confirm on
set reso off
set sysmenu off
resfile=SET("RESO",1)
select 0
use &resfile
locate for id="COLORSET" AND NAME="MATCHUP"
if ! found()
	append from matchup for ID="COLORSET" AND NAME="MATCHUP"
endif
use
set reso on
	
if iscolor()
	set color set to matchup
else
	set color set to matchupbw
endif

release i,j, deck, shdeck, card, drow, dcol, exit
public i,j, deck, shdeck, card, exit
=rand(-1)
dime deck(54,2)
dime shdeck(54,3)
set safety off
define window matchup from 0,0 to 24,79 
acti wind matchup
@ 0,48 say "(c)1992 RamPower Systems" 
@ 1,51 to 3,69 double color scheme 16
@ 2,52 say "     Matchup     " color scheme 16
@ 4,54 say "(619) 562-9370"
@ 21,51 say "Press [Esc] to quit"

do makedeck
do shuffle
@ 5,48 say "Try to turn over matching"
@ 6,54 say "pairs of cards."
@ 7,45 to 13,76 double color scheme 5
@ 8,46 say  " Number of guesses:           " color scheme 5
@ 9,46 say space(30) color scheme 5
@ 10,46 say " Number of Right guesses:     " color scheme 5
@ 11,46 say space(30) color scheme 5
@ 12,46 say " Accuracy Percentage:         " color scheme 5

@ 14,45 to 19,76 double color scheme 2
@ 15,46 say "  Click on cards with mouse   " color scheme 2
@ 16,46 say " or use keyboard: Tab=forward," color scheme 2
@ 17,46 say "  Shift-Tab=back, arrow keys  " color scheme 2
@ 18,46 say " to move, Enter selects card. " color scheme 2

card1=1
card2=2
card=1
guesses=0
matches=0
match=.t.
exit=.f.
begtime=seconds()

do while .t. 
	@ 8,70 say str(guesses,4,0) color scheme 5
	@ 10,72 say str(matches,2,0) color scheme 5
	@ 12,69 say str(iif(guesses#0,matches/guesses*100,0),5,1)+"%" color scheme 5
	*** card one
	do getcard
	if ! match
		do turncard with card1
		do turncard with card2
	endif
	if exit
		do close
		return
	endif
	do drawcard
	card1=card

	*** card two
	do getcard
	if exit
		do close
		return
	endif
	do drawcard
	card2=card
	guesses=guesses+1
	if shdeck(card1,1)=shdeck(card2,1)
		shdeck(card1,3)=.T.
		shdeck(card2,3)=.T.
		wait "A match!!" window nowait
		match=.t.
		matches=matches+1
	else
		wait "Those don't match." window nowait
		shdeck(card1,3)=.f.
		shdeck(card2,3)=.f.
		match=.f.
	endif
	won=.t.
	for element=1 to 54
		if ! shdeck(element,3) 
			won=.f.
			loop
		endif
	endfor
	if won or lastkey()=1
		endtime=seconds()
		if begtime>endtime
			endtime=endtime+(24*60*60)
		endif
		allsecs=endtime-begtime
		wait "You Won!!!" window nowait
		@ 14,45 to 19,76 double color scheme 16
		@ 15,46 say "       Congratulations!       " color scheme 16
		@ 16,46 say padc("You Won!!!",30) color scheme 16
		@ 17,46 say "         Completed in:        " color scheme 16
		@ 18,46 say "         minutes,    seconds. " color scheme 16
		@ 18,51 say str(int(allsecs/60),3,0)color scheme 16
		@ 18,64 say str(allsecs%60,2,0)color scheme 16
		@ 21,51 say "                   "
		@ 21,47 say "Play again?" 
		yesno=1
		@ 21,60 get yesno function '*TH \!\<Yes; \?\<No' size 1, 7, 2 
		read
		if yesno=1
			clear
			acti wind matchup
			@ 0,48 say "(c)1992 RamPower Systems" 
			@ 1,51 to 3,69 double color scheme 16
			@ 2,52 say "     Matchup     " color scheme 16
			@ 4,54 say "(619) 562-9370"
			@ 21,51 say "Press [Esc] to quit"
			for element=1 to 54
			 shdeck(element,1)=.f.
			 shdeck(element,2)=.f.
			 shdeck(element,3)=.f.
			endfor
			do shuffle	
			@ 5,48 say "Try to turn over matching"
			@ 6,54 say "pairs of cards."
			@ 7,45 to 13,76 double color scheme 5
			@ 8,46 say  " Number of guesses:           " color scheme 5
			@ 9,46 say space(30) color scheme 5
			@ 10,46 say " Number of Right guesses:     " color scheme 5
			@ 11,46 say space(30) color scheme 5
			@ 12,46 say " Accuracy Percentage:         " color scheme 5

			@ 14,45 to 19,76 double color scheme 2
			@ 15,46 say "Click on cards with mouse     " color scheme 2	
			@ 16,46 say "or use keyboard: Tab=forward, " color scheme 2
			@ 17,46 say "Shift-Tab=back, or arrow keys " color scheme 2
			@ 18,46 say "to move, Enter selects card.  " color scheme 2
			card=1
			card1=1
			card2=2
			guesses=0
			matches=0
			match=.t.
			begtime=seconds()
			loop
		else
			do close 
			return
		endif
	endif
enddo
set color set to default
set confirm &matconf
set bell &matbel
set sysmenu &matsmenu
return

procedure getcard
	do while .t.
		key = inkey(0,"HM")
		if key=27
			exit=.t.
			exit
		endif
		if key = 151		&& Single mouse click
			row = MROW()	&& Get mouse pointer position
			col = MCOL()
			r=(row)%4
			c=(col-1)%5
			if row=-1 or col=-1 or col>44 or r=3 or c=3 or c=4
				loop
			endif
			card=int((col-1)/5+1) + int(row/4)*9
			if shdeck(card,3)
				?? chr(7)
				wait "That card is already turned" window nowait
				loop
			endif
			exit
		endif
		do case
		case key=13
			if shdeck(card,3)
				?? chr(7)
				wait "That card is already turned" window nowait
				loop
			endif
			exit
		case key=9 or key=4
			if shdeck(card,3)
				=drawcard()
			else
				=turncard(card) 
			endif
			card=card+1
			if card=55
				card=1
			endif
			if shdeck(card,3)
				=drawlight()
			else
				=turnlight(card) 
			endif
		case key=15 or key=19
			if shdeck(card,3)
				=drawcard()
			else
				=turncard(card) 
			endif
			card=card-1
			if card=0
				card=54
			endif
			if shdeck(card,3)
				=drawlight()
			else
				=turnlight(card) 
			endif
		case key=24
			if shdeck(card,3)
				=drawcard()
			else
				=turncard(card) 
			endif
			if card<46
				card=card+9
			endif
			if shdeck(card,3)
				=drawlight()
			else
				=turnlight(card) 
			endif
		case key=5
			if shdeck(card,3)
				=drawcard()
			else
				=turncard(card) 
			endif
			if card>9
				card=card-9
			endif
			if shdeck(card,3)
				=drawlight()
			else
				=turnlight(card) 
			endif
		endcase
	enddo
	shdeck(card,3)=.T.
	return	&& eof Getcard
	
procedure turncard
	parameter turncard
	row=int((turncard-1)/9)*4
	col=(turncard-1)%9*5+1
	@ row,col say "ͻ" color scheme 15
	@ row+1,col say "" color scheme 15
	@ row+1,col+1 say "" color scheme 16
	@ row+1,col+2 say "" color scheme 15
	@ row+2,col say "ͼ" color scheme 15
	return

procedure turnlight
	parameter turncard
	row=int((turncard-1)/9)*4
	col=(turncard-1)%9*5+1
	@ row,col say "ͻ" color scheme 17
	@ row+1,col say "" color scheme 17
	@ row+1,col+1 say "" color scheme 18
	@ row+1,col+2 say "" color scheme 17
	@ row+2,col say "ͼ" color scheme 17
	return

procedure drawcard
	colr=iif(asc(shdeck(card,2))>4 or asc(shdeck(card,1))=1,"14","13")
	row=int((card-1)/9)*4
	col=(card-1)%9*5+1

	@ row,col say padr(shdeck(card,1),3) color scheme &colr
	if asc(shdeck(card,1))=1 
		@ row+1,col say "JOK" color scheme 13
	else
		@ row+1,col say " "+shdeck(card,2)+" " color scheme &colr
	endif
	@ row+2,col say padl(shdeck(card,1),3) color scheme &colr
	return
	
procedure drawlight
	colr=iif(asc(shdeck(card,2))>4 or asc(shdeck(card,1))=1,"14","13")
	row=int((card-1)/9)*4
	col=(card-1)%9*5+1

	@ row,col say padr(shdeck(card,1),3) color scheme 17
	if asc(shdeck(card,1))=1 
		@ row+1,col say "JOK" color scheme 18
	else
		@ row+1,col say " "+shdeck(card,2)+" " color scheme 18
	endif
	@ row+2,col say padl(shdeck(card,1),3) color scheme 17
	return

procedure shuffle
i=1
j=54
for c=1 to 54
	do while .t.
		sh=irand()
		if type("shdeck(sh,1)")="C" 
			loop
		else
			shdeck(sh,1)=deck(c,1)
			shdeck(sh,2)=deck(c,2)
			wait deck(c,1)+deck(c,2) window nowait
			exit
		endif
	enddo
endfor
wait clear
c=1
for row=0 to 23 step 4
	for col=1 to 45 step 5
		@ row,col say "ͻ" color scheme 15
		@ row+1,col say "" color scheme 15
		@ row+1,col+1 say "" color scheme 16
		@ row+1,col+2 say "" color scheme 15
		@ row+2,col say "ͼ" color scheme 15
	endfor
endfor
*release deck
return	&& eof Shuffle

FUNCTION irand
RETURN int((j-i+1)*rand()+i)

procedure close
	release i,j, shdeck, card, exit
	release window matchup
	if iscolor()
		set color set to clear
	else
		set color set to bwnew
	endif
	set sysmenu on
	return

procedure makedeck
for r=1 to 13
	for s=1 to 4
		do case
		case r=1
			card="A"
		case r>1 and r<11
			card=ltrim(str(r,2,0))
		case r=11
			card="J"
		case r=12
			card="Q"
		case r=13
			card="K"
		endcase
		do case
		case s=1
			suite=""
		case s=2
			suite=""
		case s=3
			suite=""
		case s=4
			suite=""
		endcase
		deck((s-1)*13+r,1)=card
		deck((s-1)*13+r,2)=suite
	endfor
endfor
deck(53,1)=""
deck(54,1)=""
deck(53,2)=" "
deck(54,2)=" "
return

