#INCLUDE fld.hdr
#INCLUDE STRING.HDR
#INCLUDE DATABASE.HDR
#INCLUDE IO.HDR

VARDEF
  UINT   r
  CHAR   v
  UINT   cnt
ENDDEF

DBFDEF dirfile
  CHAR( 40 )  name
  INT( 2 )    age
  DATE        birth
  LOGICAL     alive
ENDDEF

INDEXDEF
  CHAR( 40 )  i_name   dirfile->name
ENDDEF

PROCEDURE scrn_dos PROTOTYPE

PROCEDURE Force_Main

  OPEN "test.dbf" ALIAS dirfile
  SET ALIAS i_name TO "test.fdx"
  !dirfile INDEX i_name
  !dirfile SET INDEX TO i_name
  !dirfile GOTO TOP

  ? "Working with "+ I_STR( Fld_Count( dirfile ) ), " fields"
  ? "press any key..."
  GET_KEY()

  DO WHILE .NOT. A_EOF( dirfile )
    CLEAR
    FOR r = 1 TO Fld_Count( dirfile )
      ? "Field:  ", Fld_Name( dirfile, r )
      ? "Type:   ", Fld_Type( dirfile, r )
      cnt = Fld_Length( dirfile, r )
      ? "Width:  ", cnt
      v = Fld_Value( dirfile, r, A_RECNO( dirfile ) )
      ? "Raw:    ", "'"+ v +"'"
      ? "Data:   ", "'"+ LEFT( v, cnt ) +"'"
      ?
    NEXT

    GET_KEY( )
    !dirfile SKIP
  ENDDO

  CLOSE ALL
ENDPRO