*:*********************************************************************
*:
*:        Program: C:\FOXPRO2\TOOLS\VIEWARR.PRG
*:        Purpose: Converts an array to a DBF and allows users to
*:                 BROWSE It.  Seems To Work Only On Multidimensional
*:                 Arrays.
*:
*:         System: ViewArray
*:         Author: Mike Dwyer
*:      Copyright (c) 1992, Custom Microware
*:  Last modified: 01/13/92     22:25
*:
*:
*:      Documented 01/21/92 at 00:43               FoxDoc  version 2.10
*:*********************************************************************
*:
*: Usage: DO VIEWARRAY WITH <arrayname>
*:
PARAMETERS Thearray
PRIVATE X,Y,Fieldlist,Columntype,Columnlen,Columndec,Tmpstr
Numofcols= ALEN(Thearray,2)
Fieldlist= "("
FOR X= 1 TO  Numofcols
   ** Go Through Each Column of row 1, sampling data so that
   ** a good database structure can be created

   Columntype = TYPE("Thearray[1,x]")
   Columndec  = 0
   DO CASE

   CASE Columntype= "C"
      Columnlen= LEN(TRIM(Thearray[1,X]))
      ** Determine the maximum length of any character elements
      FOR Y=1 TO ALEN(Thearray,1)
         Columnlen= MAX(Columnlen,LEN(TRIM(Thearray[y,x])))
      ENDFOR (y)
      Columnlen= Min(Columnlen,254)
      
   CASE Columntype= "N" .OR. Columntype= "F"
      Columnlen= 10
      IF "." $ STR(Thearray[1,X])
         Tmpstr= ALLTRIM(STR(Thearray[1,X]))
         Columndec= LEN(Tmpstr)-AT(".",Tmpstr)
      ENDIF ("." $ STR(thearray[1,X]))
   CASE Columntype= "L"
      Columnlen= 1
   CASE Columntype= "D"
      Columnlen= 8
   OTHERWISE
      Columnlen= 10
   ENDCASE
   Fieldlist= Fieldlist+"COL_"+ALLTRIM(STR(X,3))+" "+Columntype
   Fieldlist= Fieldlist+"("+ALLTRIM(STR(Columnlen))
   IF Columndec<> 0
      Fieldlist= Fieldlist+","+ALLTRIM(STR(Columndec))
   ENDIF (columndec<> 0)
   Fieldlist=Fieldlist+"), "
ENDFOR (X)
Fieldlist= LEFT(Fieldlist,LEN(Fieldlist)-2)+")"

CREATE CURSOR ADIR &fieldlist
APPEND FROM ARRAY Thearray
GO TOP
BROWSE
USE
RETURN .T.


*: EOF: VIEWARR.PRG
