

Bulk v2.1 Owner's Manual

(c)1990 Cool Baby Software & Mark K. Krieg


Disclaimer: You undertake to use BULK at your own risk.  The 
author assumes no liability for damages of any kind resulting from 
your use of BULK.


BULK may be freely used and shared with others; there is no 
required registration fee. (If you like BULK and find it useful, 
please do consider sending a contribution! If you can't afford it, 
don't worry about it ... it's free. Either way, I would appreciate 
a note telling about your thoughts on Bulk and how you're using 
it!)


Bulk features full mouse support ...


Table of Contents:

     I.   What is Bulk Mail?
    II.   What is Bulk?
   III.   Bulk requires the following information from you:

            *  An INPUT file name.
            *  An OUTPUT file name.
            *  The output TYPE.
            *  Large field name.
            *  Zip field name.
            *  State field name.

           (Optional)   *  Create a configuration file (Y/N)
                        *  Hearer Labels (Y/N)
                        *  Blank Labels (Y/N)
                        *  Sticker Information Labels (Y/N)
                        *  200 Record Check (Y/N)
                        *  Text Information Screens (Y/N)
                        *  Input Screens (Y/N)
    IV.   Tips ...
     V.   History of Bulk ... (read this section for update information)


I. What is Bulk Mail?

This is a preprocess sort done by an individual or corporation to 
save on the cost of postage. A permit from your local postal 
service is required to do this ... contact your local Post Office 
for more information. There is an initial fee involved ... but the 
postage savings, through the years, far outweigh the fee. 200 
like items are the minimum requirement for Bulk Mail.

After acquiring a permit, you'll receive information on the process 
of sorting the mail. Most organizations print labels or envelopes 
in Zip Code order. After the labels are in place, they then have 
to hand sort all the items, into the proper order required by the 
U.S. Postal Service. This is a time consuming process, but for 
large mailing ... still worth the effort. Currently the first 
class Postal rate is 25 cents per piece. Having a Bulk Mail Permit will 
reduce that to 17.6 cents per piece. If you are a Non-Profit 
organization, another permit can be applied for, reducing the rate 
to 8.4 cents per piece. Worth looking into!?!?

That's where this Bulk program comes in ...

Bulk lets you say, "Goodbye!" to the labor of hand sorting. Just 
apply the labels in the order they print. Bulk will even tell you 
where the breaks are and what sticker needs to be applied!


II. What is Bulk?

Bulk is a bulk mail utility. It sorts a dBase III (+) database 
file into the proper order required by the U.S. Postal Service.

Bulk will not make any modifications to your original database. 
Instead, Bulk creates a duplicate database (including group 
headers) and saves this in the proper record order. There is no 
need for indexes. Just output the new database to reports, labels 
or envelopes.

You do not need dBase in order to use Bulk. Any program that will 
export data to a .DBF (dBase III file format) will do.

Bulk was designed to be part of a larger effort by Cool Baby 
Software called MList which should be appearing soon on the 
Freeware market. It will include an integrated mailing list 
manager available in MS-DOS, Windows and Macintosh environments.

Bulk is also Freeware ... meaning it's FREE!       Enjoy ...


III. Bulk requires the following information from you:

*  An INPUT file name.

The name of the .DBF you wish to process.  Bulk will add in the 
extension for you. Again, this database does not have to come 
straight from dBase. Any application that will export to dBase 
III will do. Make sure that the extension is .DBF when you export.

*  An OUTPUT file name.

The name you wish to call the resultant file. The extension is 
automatically added. .DBF for dBase file format, .SDF for fixed 
length ASCII and .TXT for delimited. (See below for more details 
on these file types)

*  The output TYPE.

     ( ) dBase compatible (.DBF) file

     ( ) SDF - fixed length ASCII (.SDF)
         w/ carriage returns & line feeds

     ( ) Delimited - in the form: (.TXT)
         "data","data","data" ...

(any combination of the above can be selected using an 'X')


*  Large field name.

Bulk writes headers to show where the groups separate. This field 
should be 20 characters or larger. If it is smaller ... the names 
will truncate. This could be a Last Name field or an Address 
field, etc ...

*  Zip field name.

Bulk needs to know the name of your Zip field. Bulk only takes 
the first 5 digits of the zip. If you have a separate field for 
the Plus 4, that's fine. Just give Bulk the name of the field 
containing the first 5 digits.

*  State field name.

Bulk needs to know the name of your State field. (If you have no 
state field, all states will be placed with Mixed states in Zip 
Code order. You can then hand sort just the mixed states to 
extract any state matches)

*  Create a configuration file (Y/N)

This allows you to create a BULK.INI file. This file is loaded 
with descriptive comments. This file will be created with the 
'default' values you enter in the input fields. At this point 
after selecting GO, you will receive another input screen 
allowing you to changes other attributes of Bulk to be recorded 
in the BULK.INI file.

This file can, at any time, be edited with an ASCII editor or 
word processor (just make sure that you save it as ASCII or Text 
Only) to change the values.

If a BULK.INI file already exists and you desire to create 
another, Bulk will rename you're old .INI file to BULK.OLD and 
create the new one.

*  Hearer Labels (Y/N)

Header labels are descriptive comments that are placed in the 
resultant file to ease the work load of bulk mailing. These 
comments are placed in the 'Large field name' value that was 
entered.

The first comment label is the total number of valid records. 
This is needed for the form that is given to the Postmaster.

The second comment label is the total number of invalid labels 
(records without a zip code or records with alphabetic characters 
in the zip field ... foreign addresses) followed by that group.

The third comment label is the total number of five digit zips 
for each qualifying five digit match. Example: the first set of 
five digit matches is on zip 21045. The comment label will read 
...

(17) 5 digit - Zip # 21045

Meaning that there are seventeen zip codes with the number 21045. 
This same comment is then applied for each type of match 
conditions ... 3 digit, state and mixed states.

*  Blank Labels (Y/N)

This gives you an option to print blank labels between the header 
label and the group of matches that follow it.

*  Sticker Information Labels (Y/N)

This will add one additional description label informing you which 
stickers to use for the top of the matched group.

EXAMPLE: "Use the red 'D' sticker"

*  200 Record Check (Y/N)

This switch controls whether Bulk will look for 200 valid records 
or not. 200 is the minimum required by the Postal Service. In the 
event you have a smaller database and you still want it sorted 
into bulk order, you can turn this switch off so that you don't 
receive a message prompt every time it process the database.

*  Text Information Screens (Y/N)

This gives you the option to view the introduction screen upon 
execution of Bulk and the credit screen at the end of the 
session. I hate programs that won't let you integrate them into 
your system without paging through screens like this ... so after 
you create a .INI file you have the option to turn them off.

*  Input Screens (Y/N)

This gives you the option to bypass the input screens as well. 
Only turn this off when you have a well working BULK.INI file 
established. By turning this off as well as the test information 
screens, you can seamlessly integrate Bulk into a batch file 
process or menu system!


IV. Tips ...

You can use multiple BULK.INI files.

1. Place BULK.EXE somewhere in your path. If you use dBase, 
Foxbase or Clipper and have that application in the path, you may 
just want to place BULK.EXE in the same directory.

2. Create separate subdirectories for each database that you will 
use Bulk with.

Example:

PATH = C:\;C:\DOS;C:\FOXBASE;C:\WORDSTAR;C:\PCTOOLS

Place BULK.EXE in the Foxbase directory.

           C:\ ---- - DOS
                    |
                    |- FOXBASE ----- - HOME_DBF
                    |               |
                    |- WordStar     |- WORK_DBF
                    |               |
                    |- PCTOOLS      |- CHURCH
                    |
                    |- SCHOOL

Go to one of those subdirectories ...

C:\FOXBASE\CHURCH

and execute Bulk ...

C:\FOXBASE\CHURCH> BULK [enter]

NOTE: If you used the dialog box to change directories to a 
database file and saved this configuration in a BULK.INI file, 
Bulk does not record the full path ... so if you go to execute 
Bulk using a BULK.INI file and it can't find the database ... 
Bulk will throw-up on you!

3. Create separate BULK.INI files in each subdirectory.

The next time you need to run this bulk program, just go to the 
proper subdirectory and execute Bulk. If the .INI file exists, it 
will load automatically.

For such a procedure ... I recommend turning off the text 
information screens as well as the input data screens.


V. History of Bulk ...

Bulk v2.1  11/90 -------------------------------------------------

Continued refinement of code. Wiped out some needless variables, 
cleaned up some other code. Trying to optimize speed ... if 
possible.

Bulk v2.0a 10/90 -------------------------------------------------

Several internal functions cleaned up. Beginning to streamline 
code through new programming techniques. Deleted comments out of 
BULK.INI file.

Bulk v2.0  10/90 -------------------------------------------------

Major speed enhancements. Bulk no longer goes to the top of the 
database after finding a 'match' to precede to the next find. 
Instead, it goes to the position where it last left off. This may 
not be noticeable on small databases (200-400 records), but on 
large ones (1500-3000) it will save minutes of time!

Many small cosmetic changes. A few small bug fixes when reading 
from a BULK.INI file exclusively.

Addition of two more option in the configuration file:
  1. BLANK LABELS = (Y/N)
  2. STICKER LABELS = (Y/N)

This provides more flexibility to the user. These options have been 
added at the end of the BULK.INI file order so that if you're 
using existing BULK.INI files from older versions ... you only 
have to add the following lines at the end of the current file(s):

BLANK LABELS = Y -or- N
STICKER LABELS = Y -or- N

You can modify the BULK.INI file(s) with any ASCII editor or any 
word processor ... just make sure that if you use a word 
processor, you SAVE the file AS: TEXT ONLY or ASCII format.

If you don't wish to select either one of these options as N, 
there is no need to modify your BULK.INI file.

Bulk v1.9a  9/90 -------------------------------------------------

Minor bug corrected with looping procedure.

Bulk v1.9   9/90 -------------------------------------------------

Another option has been added to the configuration file. You now 
have a ability to suspend the printing of 'header labels'. These 
are the descriptive labels that print to space out the breaks in 
the bulk order. By toggling this off, you will have the original 
database in bulk order with no added fields ... also this is 
useful if you send the printing to a mail service ... they have 
no need of these additional labels.

Bulk v1.8   9/90 -------------------------------------------------

Many changes with the way Bulk handles the config file (Bulk.ini) 
internally. Before this modification, Bulk would return the 
config values ... however, after a value was returned to Bulk 
with no leading spaces. This did not give you much room to modify 
the entries if you choose to do so after the config file placed 
them in Bulk. Now you can.

Bulk v1.7   8/90 -------------------------------------------------

The three options in the BULK.INI configuration file can now  be 
placed in at execution time. If 'Y' is selected to create a 
BULK.INI file, a second input screen appears allowing you to 
enter values into it.

Bulk v1.6   8/90 -------------------------------------------------

Bulk can now create it's own configuration file 'BULK.INI' using 
an added option on the input screen. It will create the same 
file, with comments, as well as write the current input 
parameters that you've just given it in the input screen. If you 
have an existing BULK.INI file, it will be renamed BULK.OLD.

The BULK.INI file can still be edited with an ASCII editor at any 
time.

Bulk v1.5   8/90 -------------------------------------------------

Many changes to the screen ... the visual feedback is easier to 
understand!

Bulk v1.4   8/90 -------------------------------------------------

A configuration file (BULK.INI) has been added. The file items 
are the same as the input screen with the addition of three new 
items ... SCREENS, INPUT MODULE & 200 Valid Records Check. This 
allows you to bypass the documentation screens, as well as the 
finishing screen, the input screen and the 200 record check. This 
should help to incorporate Bulk into a batch file routine, 
combined with other code.

Details on setting up the configuration file are contained inside 
the default BULK.INI file. This file must reside in the same 
directory as BULK.EXE

Bulk v1.3    8/90 -------------------------------------------------

Bulk now checks for 200 valid records. If there is less, the user 
has an option to quit execution or to continue. Other bugs have 
been fixed ... esp. when using very large databases of over 1500 
- 2000 records. Increased speed to the State sort routine, as 
well as overall speed improvements.

Bulk v1.2    8/90 -------------------------------------------------

Added more user feedback to the processing screen. Bar graphs 
give the user an idea of where the program is at in processing 
the database. The same totals and valid record counts that would 
be added to the headers labels appear on the screen as well.

Bulk v1.1    8/90 -------------------------------------------------

Added the current number of valid items to the header labels. 
Also added the item count per group of finds to the header labels.

Bulk v1.0    7/90 -------------------------------------------------

This was a separate module designed to work in MList (an 
integrated mailing list program for the Freeware market, 
developed by Cool Baby Software). Instead of trying to code 
everything in one shot, as I often do, I separated this complex 
procedure and made it a stand alone application with a simplified 
from end. Later, through a friends advice (Marco Ciavolino - the 
faithful Cool Baby Beta tester), the front end was made open to 
any dBase file structure so that it could be used as a separate 
standalone utility.

Bulk was not designed to be fancy.
However, it was designed to meet two criteria ...

1. That is works.
2. That is serves some useful purpose!

I've downloaded hundreds of megabytes of software in my years of 
computing. Most of what I've found is shareware ... and most did 
not meet the two criteria listed above. I can not imagine people 
paying $25 to $50 for things that don't even work! I feel that 
there should be more freeware! Then if you like it and use it, 
give the author something for his time and effort.

If you find bugs or flaws with Bulk, please write to me and let 
me know ... I really want this to be flawless. Give me some 
detail as to what happened and a list of the hardware you were 
using as well as a printout of your config.sys and autoexec.bat. 
Leave an address and phone number ... I may need to get in touch 
with you.

Mark K. Krieg
2549 S. George St. Box C15
York, PA  17403

Disclaimer: You undertake to use BULK at your own risk.  The 
author assumes no liability for damages of any kind resulting 
from your use of BULK.

Bulk was written using: -------------------------------- SOFTWARE:

- genSoft/dbFast Plus v1.47

(My compliments to Clyde Dever, the author of dbFast Plus, Windows 
& Mac. He has written exceptional products! I'm thankful for the 
opportunity in beta testing these fine products!)

- Microsoft Quick C v2.0 & Linker v4.06
- WordStar International's WordStar v6.0c

(Of course ... what else is there !?!?)

- VDE (Video Display Editor) v1.54 by Eric Meyer

(My compliments to Eric. This is one of ... if not the finest 
piece of Public Domain software I have ever seen. And there is no 
registration fee required ... FREEWARE. His desire to place such a 
quality product on the freeware market has inspired me to do the 
same!)

-------------------------------------------------------- HARDWARE:

Kaypro 286i, 1 meg RAM, two 40 meg HD, Vega Video7 VGA, NEC GS2 
monitor(amber).

Also written & tested using:

Compaq 386/20, 2 megs RAM, 60 meg HD, Orchid Pro VGA, NEC GS2a 
monitor(white).