;  CALC SCRIPT

CLEARALL

Text


۲
۲
۲߲
۲  C A L C  
۲ܰ
۲
۲
۲
۲߲
۲                                                           
۲ܰ
۲
۲
۲
۲߲
۲                  
۲ܰ
۲
۲
۲
۰

EndText


;  Making BlanketChanges

@ 11,11
?? "Executing BlanketChange, if requested . . .             "
@ 1,2

Query

 Blanket | Old Absence Code | New Absence Code |
         | _old             | _new             |
         |                  |                  |
         |                  |                  |

 Values |    Absence Type     |
        | _old, changeto _new |
        |                     |
        |                     |

Endquery
Do_It!

Query

 Blanket | Old Absence Code | New Absence Code |
         | _old             | _new             |
         |                  |                  |
         |                  |                  |

 Absentee |    Absence Type     |
          | _old, changeto _new |
          |                     |
          |                     |

Endquery
Do_It!

EMPTY "Blanket"

;  Query Absentee for requested records

@ 11,11
?? "Locating history records for requested individuals . . ."
@ 17,23
?? ""
@ 1,2

ADD "Termnate" "Hisreqst"

Query

 Hisreqst | Social Security Number |
          | _ssn                   |
          |                        |
          |                        |

 Absentee | Social Security Number |  Name  | Department | Absence Type |
          | Check _ssn             | Check  | Check      | Check        |
          |                        |        |            |              |
          |                        |        |            |              |

 Absentee |  Date  |
          | Check  |
          |        |
          |        |

Endquery
Do_It!

RENAME "Answer" "Temp"

;  Matching descriptions to the History Report Absence types

@ 11,11
?? "Adding descriptions to the selected records . . .       "
@ 17,24
?? ""
@ 17,23
?? ""
@ 1,2


{Modify} {Restructure} {temp}
Down Down Down Down Down
"Description"  Tab  "A24"
Do_It!


Query

 Values | Absence Type | Description |
        | _type        | _desc       |
        |              |             |
        |              |             |

 Temp | Absence Type |  Description   |
      | _type        | changeto _desc |
      |              |                |
      |              |                |

Endquery
Do_It!


;  Add the Temp file records to the History file

@ 11,11
?? "Adding the selected records to the History Report . . .  "
@ 17,25
?? ""
@ 17,24
?? ""
@ 1,2


ADD "Temp" "History"

;  EMPTY the Hisreqst file

EMPTY "Hisreqst"

;  Purging the data base of all outstanding terminations

@ 11,11
?? "Purging all outstanding terminations . . .              "
@ 17,26
?? ""
@ 17,25
?? ""
@ 1,2

Query

 Termnate | Social Security Number |
          | _ssn                   |
          |                        |
          |                        |

 Absentee | Social Security Number |  Name  | Department | Absence Type |
          | Check _ssn             | Check  | Check      | Check        |
          |                        |        |            |              |
          |                        |        |            |              |

 Absentee |  Date  | Yesterday | Tardy Value | Absence Value | Unexcused Value |
          | Check  | Check     | Check       | Check         | Check           |
          |        |           |             |               |                 |
          |        |           |             |               |                 |

 Absentee | End of Period of Absence |
          | Check                    |
          |                          |
          |                          |

Endquery
Do_It!

SUBTRACT "Answer" "Absentee"

EMPTY "Termnate"


;  Sort the Values table by Absence code

SORT "Values" ON "Absence Type"


;  Date stamp the data

@ 11,11
?? "Date stamping new data since last Calc as this day . . ."
@ 17,27
?? ""
@ 17,26
?? ""
@ 1,2

Query

 Day | Yesterday | This Day |
     | _yest     | _thisday |
     |           |          |
     |           |          |

 Absentee |           Date           |       Yesterday       |
          | blank, changeto _thisday | blank, changeto _yest |
          |                          |                       |
          |                          |                       |

 Absentee |
          |
          |
          |

Endquery
Do_It!

;  Put current policy values into Absentee file

@ 11,11
?? "Calculating current values for all records . . .        "
@ 17,28
?? ""
@ 17,27
?? ""
@ 1,2

Query

 Values | Absence Type | Tardy Value | Absence Value | Unexcused Value |
        | _a           | _b          | _c            | _d              |
        |              |             |               |                 |
        |              |             |               |                 |

 Absentee | Absence Type | Tardy Value | Absence Value |
          | _a           | changeto _b | changeto _c   |
          |              |             |               |
          |              |             |               |

 Absentee | Unexcused Value |
          | changeto _d     |
          |                 |
          |                 |

Endquery
Do_It!

;  Empty the Reprimand table


EMPTY "Reprimnd"

;  Capture all tardy records

@ 11,11
?? "Capturing all tardies . . .                             "

@ 17,29
?? ""
@ 17,28
?? ""
@ 1,2

Query

 Absentee | Social Security Number |  Name  | Department | Absence Type |
          | Check                  | Check  | Check      | Check        |
          |                        |        |            |              |
          |                        |        |            |              |

 Absentee |  Date  | Yesterday | Tardy Value | Absence Value | Unexcused Value |
          | Check  | Check     | Check >0    | Check         | Check           |
          |        |           |             |               |                 |
          |        |           |             |               |                 |

 Absentee | End of Period of Absence |
          | Check                    |
          |                          |
          |                          |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Capture tardy records during the enforcement period

@ 11,11
?? "Capturing tardies during enforcement period . . .       "
@ 17,30
?? ""
@ 17,29
?? ""
@ 1,2

Query

 Period | Enforcement Period |
        | _period            |
        |                    |
        |                    |

 Day | This Day |
     | _thisday |
     |          |
     |          |

 Temp | Social Security Number |  Name  | Department | Absence Type |
      | Check                  | Check  | Check      | Check        |
      |                        |        |            |              |
      |                        |        |            |              |

 Temp |            Date             | Yesterday | Tardy Value | Absence Value |
      | Check >= _thisday - _period | Check     | Check       | Check         |
      |                             |           |             |               |
      |                             |           |             |               |

 Temp | Unexcused Value | End of Period of Absence |
      | Check           | Check                    |
      |                 |                          |
      |                 |                          |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Calculate last violation date and violation totals for tardies by individual

@ 11,11
?? "Calculating tardy violation totals by individual . . .  "
@ 17,31
?? ""
@ 17,30
?? ""
@ 1,2

Query

 Temp | Social Security Number |         Date          |
      | Check                  | calc max as Last Date |
      |                        |                       |
      |                        |                       |

 Temp |    Tardy Value    |
      | calc sum as Total |
      |                   |
      |                   |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Capture tardy reprimands due and imminent this day by individual

@ 11,11
?? "Capturing tardy reprimands due and imminent . . .       "
@ 17,32
?? ""
@ 17,31
?? ""
@ 1,2

Query

 Policy | Tardies |
        | _policy |
        |         |
        |         |

 Day | This Day |
     | _thisday |
     |          |
     |          |

 Temp | Social Security Number |   Last Date    |        Total         |
      | Check                  | Check _thisday | Check >= _policy - 1 |
      |                        |                |                      |
      |                        |                |                      |

Endquery
Do_It!
RENAME "Answer" "Temp"

; Capture positive Temp Total records (in case policy is 1)

Query

 Temp | Social Security Number | Last Date |  Total   |
      | Check                  | Check     | Check >0 |
      |                        |           |          |
      |                        |           |          |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Insert the additional Reprimnd fields in the Temp table

@ 11,11
?? "Inserting name & group fields in tardy table . . .       "
@ 17,33
?? ""
@ 17,32
?? ""
@ 1,2

Esc {Modify} {Restructure} {temp}
Down Ins Right  "Name" Tab "A35" Left Left
Down Ins Right  "Dept" Tab  "A5" Left Left
Down Down Down  "Reason for Reprimand" Tab  "A40"
Do_It!

;  Fill the Name and Dept fields in the Temp table

@ 11,11
?? "Matching name and group to each tardy individual . . .  "
@ 17,34
?? ""
@ 17,33
?? ""
@ 1,2

Query

 Absentee | Social Security Number | Name  | Department |
          | _ssn                   | _name | _dept      |
          |                        |       |            |
          |                        |       |            |

 Absentee |
          |
          |
          |

 Temp | Social Security Number |      Name      |      Dept      |
      | _ssn                   | changeto _name | changeto _dept |
      |                        |                |                |
      |                        |                |                |

 Temp |
      |
      |
      |

Endquery
Do_It!

;  Fill the Reason for Reprimand field in the Temp table

@ 11,11
?? "Labeling tardy reprimands as due or imminent . . .      "
@ 17,35
?? ""
@ 17,34
?? ""
@ 1,2

Query

 Policy | Tardies |
        | _policy |
        |         |
        |         |

 Temp |     Total     |              Reason for Reprimand                 |
      | = _policy - 1 | changeto "Excessive Tardiness Reprimand Imminent" |
      |               |                                                   |
      |               |                                                   |

Endquery
Do_It!

Query

 Policy | Tardies |
        | _policy |
        |         |
        |         |

 Temp |   Total    |              Reason for Reprimand                 |
      | >= _policy | changeto "Excessive Tardiness Reprimand Due Now"  |
      |            |                                                   |
      |            |                                                   |

Endquery
Do_It!


;  Load the tardy Temp records to the Reprimnd file

@ 11,11
?? "Loading the tardy reprimands to Reprimand report file . "
@ 17,36
?? ""
@ 17,35
?? ""
@ 1,2

ADD "Temp" "Reprimnd"

;  Capture all unexcused records

@ 11,11
?? "Capturing all unexcuseds . . .                         "
@ 17,37
?? ""
@ 17,36
?? ""
@ 1,2

Query

 Absentee | Social Security Number |  Name  | Department | Absence Type |
          | Check                  | Check  | Check      | Check        |
          |                        |        |            |              |
          |                        |        |            |              |

 Absentee |  Date  | Yesterday | Tardy Value | Absence Value | Unexcused Value |
          | Check  | Check     | Check       | Check         | Check >0        |
          |        |           |             |               |                 |
          |        |           |             |               |                 |

 Absentee | End of Period of Absence |
          | Check                    |
          |                          |
          |                          |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Capture unexcused records during the enforcement period

@ 11,11
?? "Capturing unexcuseds during enforcement period . . .    "
@ 17,38
?? ""
@ 17,37
?? ""
@ 1,2

Query

 Period | Enforcement Period |
        | _period            |
        |                    |
        |                    |

 Day | This Day |
     | _thisday |
     |          |
     |          |

 Temp | Social Security Number |  Name  | Department | Absence Type |
      | Check                  | Check  | Check      | Check        |
      |                        |        |            |              |
      |                        |        |            |              |

 Temp |            Date             | Yesterday | Tardy Value | Absence Value |
      | Check >= _thisday - _period | Check     | Check       | Check         |
      |                             |           |             |               |
      |                             |           |             |               |

 Temp | Unexcused Value | End of Period of Absence |
      | Check           | Check                    |
      |                 |                          |
      |                 |                          |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Calculate last violation date and violation totals for unexcused by individual

@ 11,11
?? "Calculating unexcused violation totals by individual . ."
@ 17,39
?? ""
@ 17,38
?? ""
@ 1,2

Query

 Temp | Social Security Number |         Date          |
      | Check                  | calc max as Last Date |
      |                        |                       |
      |                        |                       |

 Temp |  Unexcused Value  |
      | calc max as Total |
      |                   |
      |                   |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Capture unexcused reprimands due and imminent this day by individual

@ 11,11
?? "Capturing unexcused reprimands due and imminent . . .   "
@ 17,40
?? ""
@ 17,39
?? ""
@ 1,2

Query

 Policy | Unexcused Absences |
        | _policy            |
        |                    |
        |                    |

 Day | This Day |
     | _thisday |
     |          |
     |          |

 Temp | Social Security Number |   Last Date    |        Total         |
      | Check                  | Check _thisday | Check >= _policy - 1 |
      |                        |                |                      |
      |                        |                |                      |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Capture positive Temp Total records (in case policy is 1)

Query

 Temp | Social Security Number | Last Date |  Total   |
      | Check                  | Check     | Check >0 |
      |                        |           |          |
      |                        |           |          |

Endquery
Do_It!
RENAME "Answer" "Temp"

; Insert the additional Reprimnd fields in the Temp table

@ 11,11
?? "Inserting name & group fields in unexcused table . . . "
@ 17,41
?? ""
@ 17,40
?? ""
@ 1,2

Esc {Modify} {Restructure} {temp}
Down Ins Right  "Name" Tab "A35" Left Left
Down Ins Right  "Dept" Tab  "A5" Left Left
Down Down Down  "Reason for Reprimand" Tab  "A40"
Do_It!

;  fill the name and Dept fields in the Temp table

@ 11,11
?? "Matching name & group to each unexcused individual . . . "
@ 17,42
?? ""
@ 17,41
?? ""
@ 1,2

Query

 Absentee | Social Security Number | Name  | Department |
          | _ssn                   | _name | _dept      |
          |                        |       |            |
          |                        |       |            |

 Absentee |
          |
          |
          |

 Temp | Social Security Number |      Name      |      Dept      |
      | _ssn                   | changeto _name | changeto _dept |
      |                        |                |                |
      |                        |                |                |

 Temp |
      |
      |
      |

Endquery
Do_It!

;  Fill the Reason for Reprimand field in the Temp table

@ 11,11
?? "Labeling each unexcused reprimand due or imminent . . . "
@ 17,43
?? ""
@ 17,42
?? ""
@ 1,2

Query

 Policy | Unexcused Absences |
        | _policy            |
        |                    |
        |                    |

 Temp |     Total     |              Reason for Reprimand               |
      | = _policy - 1 | changeto "Unexcused Absence Reprimand Imminent" |
      |               |                                                 |
      |               |                                                 |

Endquery
Do_It!


Query

 Policy | Unexcused Absences |
        | _policy            |
        |                    |
        |                    |

 Temp |   Total    |              Reason for Reprimand              |
      | >= _policy | changeto "Unexcused Absence Reprimand Due Now" |
      |            |                                                |
      |            |                                                |

Endquery
Do_It!

;  Load the unexcused Temp records to the Reprimnd table

@ 11,11
?? "Loading the unexcused reprimands to report file . . .   "
@ 17,44
?? ""
@ 17,43
?? ""
@ 1,2

ADD "Temp" "Reprimnd"

;  Capture all absence records

@ 11,11
?? "Capturing all absences . . .                            "
@ 17,45
?? ""
@ 17,44
?? ""
@ 1,2

Query

 Absentee | Social Security Number |  Name  | Department | Absence Type |
          | Check                  | Check  | Check      | Check        |
          |                        |        |            |              |
          |                        |        |            |              |

 Absentee |  Date  | Yesterday | Tardy Value | Absence Value | Unexcused Value |
          | Check  | Check     | Check       | Check >0      | Check           |
          |        |           |             |               |                 |
          |        |           |             |               |                 |

 Absentee | End of Period of Absence |
          | Check                    |
          |                          |
          |                          |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Capture absences during the enforcement period

@ 11,11
?? "Capturing absences during the enforcement period . . .  "
@ 17,46
?? ""
@ 17,45
?? ""
@ 1,2

Query

 Period | Enforcement Period |
        | _period            |
        |                    |
        |                    |

 Day | This Day |
     | _thisday |
     |          |
     |          |

 Temp | Social Security Number |  Name  | Department | Absence Type |
      | Check                  | Check  | Check      | Check        |
      |                        |        |            |              |
      |                        |        |            |              |

 Temp |            Date             | Yesterday | Tardy Value | Absence Value |
      | Check >= _thisday - _period | Check     | Check       | Check         |
      |                             |           |             |               |
      |                             |           |             |               |

 Temp | Unexcused Value | End of Period of Absence |
      | Check           | Check                    |
      |                 |                          |
      |                 |                          |

Endquery
Do_It!
RENAME "answer" "Temp"


;  Flag with logical the end of each period of absence

@ 11,11
?? "Flagging the last day of each period of absence . . .   "
@ 17,47
?? ""
@ 17,46
?? ""
@ 1,2

Query

 Temp | End of Period of Absence |
      | changeto 1               |
      |                          |
      |                          |

Endquery
Do_It!

Query

 Temp | Social Security Number |    Date    | Yesterday  |
      | _ssn                   | _anyday    | _daybefore |
      | _ssn                   | _daybefore |            |
      |                        |            |            |

 Temp | End of Period of Absence |
      |                          |
      | changeto 0               |
      |                          |

Endquery
Do_It!

;  Calcuate last violation data and violation totals for absences by individual

@ 11,11
?? "Calculating period of absence totals by individual . . ."
@ 17,48
?? ""
@ 17,47
?? ""
@ 1,2

Query

 Temp | Social Security Number |         Date          |
      | Check                  | calc max as Last Date |
      |                        |                       |
      |                        |                       |

 Temp | End of Period of Absence |
      | calc sum as Total        |
      |                          |
      |                          |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Capture periods of absence reprimands due and imminent this day by individual

@ 11,11
?? "Capturing absence reprimands due and imminent . . .     "
@ 17,49
?? ""
@ 17,48
?? ""
@ 1,2

Query

 Policy | Period of Absences |
        | _policy            |
        |                    |
        |                    |

 Day | This Day |
     | _thisday |
     |          |
     |          |

 Temp | Social Security Number |   Last Date    |        Total         |
      | Check                  | Check _thisday | Check >= _policy - 1 |
      |                        |                |                      |
      |                        |                |                      |

Endquery
Do_It!
RENAME "Answer" "Temp"


;  Capture positive Temp Total records (in case policy is 1)

Query

 Temp | Social Security Number | Last Date |  Total   |
      | Check                  | Check     | Check >0 |
      |                        |           |          |
      |                        |           |          |

Endquery
Do_It!
RENAME "Answer" "Temp"

;  Insert the addtional Reprimnd fields in the Temp table

@ 11,11
?? "Inserting name & group fields in the absence table . . ."
@ 17,50
?? ""
@ 17,49
?? ""
@ 1,2

Esc {Modify} {Restructure} {temp}
Down Ins Right  "Name" Tab "A35" Left Left
Down Ins Right  "Dept" Tab  "A5" Left Left
Down Down Down  "Reason for Reprimand" Tab  "A40"

Do_It!

;  Fill the name and dept fields in the Temp table

@ 11,11
?? "Matching name and group to each absence individual . . ."
@ 17,51
?? ""
@ 17,50
?? ""
@ 2,1

Query

 Absentee | Social Security Number | Name  | Department |
          | _ssn                   | _name | _dept      |
          |                        |       |            |
          |                        |       |            |

 Absentee |
          |
          |
          |

 Temp | Social Security Number |      Name      |      Dept      |
      | _ssn                   | changeto _name | changeto _dept |
      |                        |                |                |
      |                        |                |                |

 Temp |
      |
      |
      |

Endquery
Do_It!

;  Fill the Reason for Reprimand field in the Temp table

@ 11, 11
?? "Labeling absence reprimands as due or imminent . . .    "
@ 17,52
?? ""
@ 17,51
?? ""
@ 1,2


Query

 Policy | Period of Absences |
        | _policy            |
        |                    |
        |                    |

 Temp |     Total     |               Reason for Reprimand               |
      | = _policy - 1 | changeto "Excessive Absences Reprimand Imminent" |
      |               |                                                  |
      |               |                                                  |

Endquery
Do_It!

Query

 Policy | Period of Absences |
        | _policy            |
        |                    |
        |                    |

 Temp |   Total    |              Reason for Reprimand               |
      | >= _policy | changeto "Excessive Absences Reprimand Due Now" |
      |            |                                                 |
      |            |                                                 |

Endquery
Do_It!

;  Load the absence Temp records to the Reprimand file

@ 11,11
?? "Loading the absence reprimands to report file . . .     "
@ 17,53
?? ""
@ 17,52
?? ""
@ 1,2

ADD "Temp" "Reprimnd"

;  Sort the History file by data so individual reports will
;  have dates in date order

SORT "History" ON "Date"

SORT "Reprimnd" ON "Social Security Number"


DELETE "Temp"

@ 11,11
?? "Calculation of this day's reprimands complete           "
@ 17,54
?? ""
@ 17,53
?? ""
@ 1,2

BEEP
SLEEP 5000
CLEARALL


