****************************************************************************
* DBE_04.PRG
*
* CALLED FROM DBE_DEMO.PRG
*
* Demonstrates the use of the fields array as the 5th parameter of DBEDIT()
*
*  FUNCTION     SOURCE
*  ===========  ==============
*  SHADOW()     DBE_UDF.PRG
*  MILDATE()    DBE_UDF.PRG
*  DBEDIT()     EXTEND.LIB
*
*
*  NOTE:
*
*  We are not limited to displaying fields!  We can display any VALID 
*  expression as a column.  This example uses a UDF that converts a
*  DATE FIELD into a DD MMM YY format.  You can combine portions of 
*  mulitple fields:
*
*    a_field[1]="RANK+ " " + TRIM(F_NAME) + " " + L_NAME"
*
*
*****************************************************************************
USE PEOPLE
DECLARE a_field[3]

a_field[1]="NAME"
a_field[2]="RANK"
a_field[3]="MILDATE(LAST_EXAM)"
@ 23, 1 SAY "<Esc>=Exit    <Enter>=Select"
SHADOW( 4, 4, 19, 76, "N+/W")
@ 6, 4 SAY CHR(204)
@ 6,76 SAY CHR(185)
DBEDIT( 5, 5, 18, 75, a_field)
RETURN
*<EOF: DBE_04.PRG *-------------------------------------------------------*


