**************************************************************************
* DBE_FILE.PRG
*
* Creates and stuffs DBFs used by DBE_DEMO.PRG
*
**************************************************************************
stuff1= .F.
stuff2= .F.
stuff3= .F.

IF FILE("PEOPLE.DBF")
ELSE
  CREATE TEMP
  USE TEMP
  APPE BLANK
  REPLACE FIELD_NAME WITH "NAME", FIELD_TYPE WITH "C", FIELD_LEN WITH 20
  APPE BLANK
  REPLACE FIELD_NAME WITH "RANK", FIELD_TYPE WITH "C", FIELD_LEN WITH  3
  APPE BLANK
  REPLACE FIELD_NAME WITH "WPID", FIELD_TYPE WITH "C", FIELD_LEN WITH  4
  APPE BLANK
  REPLACE FIELD_NAME WITH "LAST_EXAM", FIELD_TYPE WITH "D", FIELD_LEN WITH 8
  USE
  CREATE PEOPLE FROM TEMP
  ERASE TEMP.DBF
  stuff1= .T.
ENDIF

IF FILE("SHOP.DBF")
ELSE
  CREATE TEMP
  USE TEMP
  APPE BLANK
  REPLACE FIELD_NAME WITH "UNIT", FIELD_TYPE WITH "C", FIELD_LEN WITH 20
  APPE BLANK
  REPLACE FIELD_NAME WITH "SHOP", FIELD_TYPE WITH "C", FIELD_LEN WITH 20
  APPE BLANK
  REPLACE FIELD_NAME WITH "EXAMCODE", FIELD_TYPE WITH "C", FIELD_LEN WITH  1
  APPE BLANK
  REPLACE FIELD_NAME WITH "WPID", FIELD_TYPE WITH "C", FIELD_LEN WITH  4
  USE
  CREATE SHOP FROM TEMP
  ERASE TEMP.DBF
  stuff2= .T.
ENDIF

IF FILE("DBE_DEMO.DBF")
ELSE
  CREATE TEMP
  USE TEMP
  APPE BLANK
  REPLACE FIELD_NAME WITH "FILENAME", FIELD_TYPE WITH "C", FIELD_LEN WITH 12
  APPE BLANK
  REPLACE FIELD_NAME WITH "DESCRIP", FIELD_TYPE WITH "C", FIELD_LEN WITH 50
  APPE BLANK
  REPLACE FIELD_NAME WITH "DEMOPROC", FIELD_TYPE WITH "C", FIELD_LEN WITH  8
  USE
  CREATE DBE_DEMO FROM TEMP
  ERASE TEMP.DBF
  stuff3= .T.
ENDIF

IF stuff1
  @ 23, 0 CLEAR
  @ 23, 1 SAY "Stuffing PEOPLE.DBF..."
  SET CONSOLE OFF
TEXT TO FILE P2.TXT
WALDEN STACY S      SSG226A        
WALDRON MICHAEL L   TSG214A        
WARD SPENCER D      SSG226A        
WARE JAMES C        TSG214A        
WASHINGTON HANS A   SRA002A        
WATTS ARNOLD J      SGT226A        
WEBB AUDREY L       TSG224A        
WEBSTER FRED S      1LT041A        
WEEMS RONALD        MSG009A        
WHITE HOMER W JR    SRA205A        
WHITE LEROY         SGT010A        
WHITFIELD DAVID P   SGT224A19900403
WICKER RICHARD D    SSG205A        
WILSON HAROLD W     MSG224A        
WISE KEITH L        TSG009A        
WITCHER STEVEN L    A1C012A        
WOG SCOTT O         SGT224A        
WOLFENSBERGER JAME  AMN012A        
WOODYEAR PAUL J     SRA205A        
WORRELL ARNOLD B    A1C226A        
WYNN RAY A          SRA224A19900403
ZAHN GARY C JR      AMN401A19900118
BOONE JOHN H        SSG010A        
BORTZ JILL S        MSG013A        
BRAINERD JOHN L     SSG202A        
BRANDON DARRYL      CPT041A19900214
BREMBY EFREM S      SSG224A        
BREWER MICHAEL G    SGT226A        
BRICKHOUSE KELVIN   SSG010A        
BRITT BRYAN N       SSG224A19900405
BROOKS DENNIS K     TSG010A        
BROOKS RODRICK K    TSG224A        
BROWN DAVID G       SGT010A        
BROWN KENNETH M     SGT205A        
BROWN ROBERT B      SSG002A        
BULISCHECK RONALD   1LT041A        
BURGESS RICKEY A    SSG010A        
BURNS LAWRENCE J J  SSG224A        
BURTON CECIL A      SSG013A        
BURTON JOSEPH M     TSG010A        
BURTON ROBERT S     MSG010A        
BUSH MICHAEL S      SGT010A        
BUTLER STEPHEN J    SSG010A        
BYERS DONALD W      TSG202A        
CALLAHAN KENNETH E  SSG009A        
CAMERON RONALD L    SSG204A19900403
CAMPANELLA ANITA M  TSG214A        
CARDEY SCOTT A      SGT204A        
CARIGO ANTHONY      SRA224A        
CARLISLE ANDREW L   TSG013A        
CARLL MICHAEL W     SRA009A        
CARLTON RONALD K    A1C411A19900131
CARTER RANDOLPH L   TSG226A        
CHARLES MICHAEL F   A1C401A        
CHRISTOVALE REGINA  SSG205A        
CLARK BENJAMIN F J  AMN012A        
CLEMENTS MATHEW S   SSG224A        
COLEMAN RICHARD     A1C226A        
COLEY JAMES C       SSG204A19900405
COLEY SHARON D      SSG012A        
COLLIER JOE M III   SSG012A        
COLLIER THERESA M   TSG205A        
COLLINS LARRY JR    A1C010A        
CONLEY MICHAEL A    A1C411B19900201
CORNATZER DERRICK   SSG002A        
CRIST WALTER T      AMN009A        
CROCKETT EDDIE      SSG202A        
CULVER KEVIN G      SMS411B19900312
CURL JOHN R         A1C009A        
CURRY BILLY R JR    SSG226A        
DALESSANDRO WARREN  SGT214A        
DANIEL GARY K       SSG224A19900404
DAVENPORT FENTON C  SGT202A        
DAVIS JERAMIE C     SSG226A        
DAVIS SHERMAN A     AMN401A19900307
DAVIS STEVEN P      SSG002A        
DAVIS WILLIAM J     SSG009A        
DAY OWEN L          SSG013A        
DECKER MICHAEL E    TSG013A        
DELAURELLE KATHLEE  A1C009A        
DERY PAUL H III     SRA009A        
DEVRIES STEVEN L    AMN009A        
DEXTER CHRISTINE A  AMN401A19900307
DIAMOND HAROLD G    SGT013A        
DILL JEFF H         TSG224A        
DISHAROON DONALD L  SSG041A        
DOUGLAS FOSTER L    TSG204A19900404
DOW WILLIAM T       SGT010A        
DUARTE JOHN F       SSG010A        
DUBOIS DOUGLAS K    SSG224A        
DUBOIS RHONDA L     TSG224A19900403
DUFOUR DAVID M      MSG010A        
EDWARDS REGINALD    SGT013A        
ELY SCOTT R         SSG224A19900403
EVANS MICHAEL D     SSG224A        
FABER LORELEI       SSG224A        
FAHRINGER FRANKLIN  2LT041A        
FERRELL JEFFREY A   TSG010A        
FIDDES PAUL M       SRA009A        
RABIE BRUCE R       SGT224A        
RAJKOVACZ PATRICK   SRA009A        
RANDOLPH PAMELA K   SRA224A        
RAWLS DANIEL P      SSG204A        
RAYFORD CLEVELAND   SGT010A        
REAP MICHAEL W      SSG009A        
REDDICK JOHN D      A1C010A        
RENAUD KYLE A       SSG002A        
RENNA MICHAEL P     SRA013A        
REYNOLDS MICHAEL E  SSG013A        
REYNOLDS SHAWN M    1LT041A        
RIFFENBURG ALLEN C  A1C009A        
ROBERTSON ELWOOD J  SGT205A        
ROBLES MARCO A      SRA411B        
RODGERS CHARLES B   SSG411B        
RODGERSON DALE W    SRA009A        
ROMAIN SHANNON R    TSG226A        
ROSS ERWIN E        AMN009A        
SABATINI RAYMOND J  SSG010A        
SAGE KEITH L        A1C214A19900329
SANTAMARIA ELEUTER  SSG041A19900221
SCHLITTENHARDT DAV  SMS002A        
SCHWAB JOHN M       SGT401A19900118
SCOTT DARRELL E     SSG010A        
SILLS DAVID G       SSG401A        
SILVERTHORN TAMMRA  SGT010A        
SIMONETTI FRED A    TSG224A        
SIX DAVID           SGT411B        
SMALL ISAAC JR      SSG012A        
SMITH ADRIAN D      SGT013A        
SMITH GRANVILLE T   SSG224A19900404
SMITH LYDIA         TSG224A        
SMITH RUSSELL J JR  SSG205A        
SMITH STEPHEN J     SGT224A        
SMITH WILLIAM T     MSG411A19900201
SNOW BRIAN D        SSG411A        
SOLER JUAN E        SRA013A        
SPEDDING JAMES N J  MSG205A        
SPRIGGS DARRELL     SRA411B19900201
STANLEY DEBORAH B   SSG224A19900403
STARR DENNIS W      SRA013A        
STEWART MARCUS C    SSG401A        
STOWERS ODIS C      SSG204A19900405
STUBBS WILLIE D JR  TSG226A        
STULLER RICHARD E   SGT013A        
SURVELLO JOHN S     SRA224A        
SWAN SELENA S       SSG002A        
SWEETLAND ANGELA G  A1C010A        
SWEETLAND DERRICK   SSG204A19900404
TAYLOR OTIS L       SSG009A        
TERRELL JOSEPH W    SGT002A        
THOMAS DAVID C      SMS010A19890301
THOMPSON WAYNE H    SGT010A        
THOMPSON WESLEY L   SSG204A        
THORNTON RANDALL C  SSG204A19900405
THORPE RICHARD B    SRA226A        
THUL GEORGE R       SSG010A        
TOLLETTE SHELBY A   SSG401A19900118
TOMA ANETEREA P     SGT204A19900405
TUCKER ANTHONY E    TSG226A        
TUFANO DANNY R      SSG002A        
TURPIN JOHN W II    TSG010A        
TURSICK TIMOTHY P   MSG224A19900405
USHER ROBERT E JR   TSG002A        
VANDUSER JOHN D     SSG214A19900404
VANHORN TIMOTHY J   SGT214A        
VILORIA EZRA K      A1C226A        
VRBONCIC ALLAN J    SSG205A        
WADE PONDUS L       SSG226A        
WADSWORTH ROYCE G   SSG009A        
WAGNER JOSEPH K     SSG226A        
AIKEN VERNON K      SRA411A        
ALSTON PETER J JR   SRA224A        
AIKEN VERNON K      SSG009A        
ALSTON PETER J JR   A1C226A        
ARRINGTON BERNARD   SSG224A        
ASTON JOSEPH        SSG002A        
ATKINS VERNON C     SSG202A        
BAGGERLY MARK L     SGT012A        
BAKER JACKIE T      SGT202A        
BARTON JAMES B      SRA224A        
BATES JOHN D        SGT204A19900403
BAUERBACH LOUIS E   TSG411B        
BAXTER RANDY L      A1C401A19900118
BELL TERESA S       SGT214A19900403
BELLIVEAU BERNARD   SGT009A        
BELLUS LYNN M       SSG204A19900405
BENN BRIAN D        SRA002A        
BERRY MICHAEL K     A1C226A        
BISHOP DONALD N     A1C224A19900405
BLACKLOCK JAMES D   MSG010A        
BLACKMER DAVID W    MSG012A        
BOGGERTY GREGORY    A1C411A        
BONNEMA KEVIN D     A1C411A19900201
BOST KELVIN D       SSG202A        
COBB WILLIAM D JR   SGT012A        
GIPSON RUSSEL C     SRA205A        
HERMANSADER KEITH   SRA226A        
HERRMANN LOUIS J I  TSG002A        
ENDTEXT
USE PEOPLE
APPE FROM P2.TXT SDF
DELE FOR EMPTY(NAME)
PACK
USE
ERASE P2.TXT
SET CONSOLE ON
@ 23, 0 CLEAR
ENDIF

IF stuff2
  @ 23, 0 CLEAR
  @ 23, 1 SAY "Stuffing SHOP.DBF..."
  SET CONSOLE OFF

TEXT TO FILE S2.TXT
CRS                 SOUND SUPP/TEST CELLM002A
CRS                 FUEL SYSTEMS REPAIR L010A
CRS                 BASE PMEL           A013A
EMS                 STRUCTURAL REPAIR   L009A
EMS                 NDI                 A012A
EMS                 6TH AMU-1           M087A
FIS                 TEST CELL           M202A
FIS                 AGE/REPAIR/INSPECT  M204A
FIS                 CORROSION CONTROL   S205A
FIS                 STRUCTURAL REPAIR   S207A
FIS                 FUEL SYSTEM REPAIR  L214A
FIS                 ALERT HANGER        M224A
FIS                 WEAPONS FLIGHT      M226A
CES                 CARPENTRY SHOP      M401A
CES                 GROUNDS             L411A
CES                 PAVE/EQUIP SECT     L411B
HELICOPTER          HELICOPTER LIFE SUPPM041A
ENDTEXT
USE SHOP
APPE FROM S2.TXT SDF
DELE FOR EMPTY(SHOP)
PACK
USE
ERASE S2.TXT
SET CONSOLE ON
@ 23, 0 CLEAR
ENDIF


IF stuff3
  USE DBE_DEMO
  ZAP
  APPE BLANK
  REPLACE FILENAME WITH "DBEINTRO.TXT", DESCRIP WITH ;
    "Introduction to this demonstration of DBEDIT()", ;
    DEMOPROC WITH ""   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_01.PRG", DESCRIP WITH "DBEDIT()", ;
    DEMOPROC WITH "DBE_01"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_02.PRG", DESCRIP WITH "DBEDIT(5,5,18,75)", ;
    DEMOPROC WITH "DBE_02"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_03.PRG", DESCRIP WITH "DBEDIT(5,5,18,75, a_field)", ;
    DEMOPROC WITH "DBE_03"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_04.PRG", ;
    DESCRIP WITH "DBEDIT(5,5,18,75, a_field) with an expression", ;
    DEMOPROC WITH "DBE_04"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_05.PRG", ;
    DESCRIP WITH "DBEDIT() with headers",;
    DEMOPROC WITH "DBE_05"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_06.PRG", ;
    DESCRIP WITH "DBEDIT() with 2 DBFs", ;
    DEMOPROC WITH "DBE_06"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_CNST.PRG", ;
    DESCRIP WITH "Memory Variable Constants", ;
    DEMOPROC WITH ""   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_07.PRG", ;
    DESCRIP WITH "DBEDIT() with Skeleton UDF", ;
    DEMOPROC WITH "DBE_07"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_08.PRG", ;
    DESCRIP WITH "DBEDIT() with field editing capability", ;
    DEMOPROC WITH "DBE_08"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_09.PRG", ;
    DESCRIP WITH "DBEDIT() with Pop-Up Edit Function", ;
    DEMOPROC WITH "DBE_09"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_10.PRG", ;
    DESCRIP WITH "DBEDIT() with all parameters", ;
    DEMOPROC WITH "DBE_10"   
  APPE BLANK
  REPLACE FILENAME WITH "DBE_SUMM.TXT", ;
    DESCRIP WITH "Summary", ;
    DEMOPROC WITH ""   
*.. Last record..........................................................*
  APPE BLANK
  REPLACE FILENAME WITH "DBE_REF.TXT", ;
    DESCRIP WITH "References for this demonstration", ;
    DEMOPROC WITH ""   
*........................................................................*
ENDIF


IF FILE("SHOPWPID.NTX")
ELSE
  USE SHOP
  INDEX ON WPID TO SHOPWPID
  USE
ENDIF  
RETURN


* <EOF: DBE_FILE.PRG> ------------------------------------------------------*

  