*   LOADDBT.PRG - load and initialize dBTools
gPATH = GETE("DBPATH")       && fetch pathname from environment
SET PATH TO &gPATH             && use it to set path
gDRV = SUBSTR(gPATH,1,2)       && get drive name
SET DEFAULT TO &gDRV           && set default drive
gPATH = TRIM(gPATH)+"\"
mTOOLS = GETE("DBTOOLS")     && get dBTools location
mTOOLS = TRIM(mTOOLS)+"\"
mEXP = mTOOLS + "DBTOOLS"
LOAD &mEXP                     && use macro to load it
CALL DBTOOLS WITH "0"          && initialize dBTools
gPRT = GETE("DBTPRT")        && get default printer
gPRTFILE = gPATH+gPRT+".PRT"   && turn it into fully qualified filename
IF FILE(gPRTFILE)              && if it's found,
   mEXP = "11,0,0,"+gPRTFILE   && create a macro to load the printer
   CALL DBTOOLS WITH mEXP      && driver
ENDIF
RETURN
