*(TABLCOMP - compare structure or data from two tables and print the differences
 
                                   converted to RBase 3.1 6-01-90; Wm Driskell)
*(save the current quote format; restore at exit)
set var quotest text, qt integer
set var quotest = "t"
if quotest = char(116) then
set var quotest = """                 *(double quotes " are used)
else
set var quotest = '''                 *(single quotes ' are used)
endif
set quotes=null
set quotes="
 
cls
set mess off
set err mess off
set bell off
write " "
write "TABLE COMPARISON PROGRAM"
write "------------------------"
 
LABEL top
write " "
set var ans text
fillin ans using "Compare the structures or data of two tables (s/d)? "
 
if ans = "d" then
  goto datcomp
endif
if ans <> "s" then
   beep
   write "enter S or D..."
   goto top
endif
 
LABEL top2
cls
write " "
write "Compare Structure of Two Tables"
write "-------------------------------"
write " "
fillin ans using "List the columns in common or the differences (c/d)? "
if ans not in ("c","d") then
   beep
   write "enter C or D..."
   goto top2
endif
 
set var tbl1 text, tbl2 text
list
if ans = "d" then
 write " "
 write "Query: What columns are in Table 1 but not in Table 2? "
 write " "
else
 write " "
 write "Query: What columns occur in both Table 1 and Table 2? "
 write " "
endif
fillin tbl1 using "Enter name of table 1: "
fillin tbl2 using "Enter name of table 2: "
write " "
write "loading the structures..."
 
out Q$$file
set head off
set line 0
list &tbl1
out R$$file
list &tbl2
out scr
 
out nul
create tab Q$$ ( junk1 integer, Remains text 10 )
load Q$$ from Q$$file
drop col junk1 from Q$$
del Q$$file
 
create tab R$$ ( junk1 integer, Remains text 10 )
load R$$ from R$$file
out scr
drop col junk1 from R$$
del R$$file
write " "
 
set head on
set line 20
if ans = "c" then
 goto colcomp
endif
 
*(.................................................)
*(table differences routine)
write "subtracting the column names..."
sub r$$ from q$$ form r$mq$
write " "
set var title = ("Columns left in" & .tbl1 & "structure after removing" & .tbl2)
compute T$$ as rows from R$mq$
if T$$ > 0 then
 write .title
 sel all from r$mq$
else
 write " "
 write "NO DIFFERENCES FOUND"
 write " "
endif
write " "
set var ans = "n"
fillin ans using "Print the results (y/n)? "
write " "
if ans = "y" then
  out pri
   set lines 0
   write .title
   sel all from r$mq$
   out scr
   set var ans = "n"
endif
 
rem r$mq$
fillin ans using "Query the opposite way - Table 2 vs Table 1 - (y/n)? "
write " "
if ans <> "y" then
    goto cleanup
endif
 
write "subtracting the opposite way..."
write " "
sub q$$ from r$$ form q$mr$
set var title = ("Columns left in" & .tbl2 & "structure after removing" & .tbl1)
write .title
compute T$$ as rows from q$mr$
if T$$ > 0 then
  sel all from q$mr$
else
  write " "
  write "NO DIFFERENCES FOUND"
  write " "
endif
 
write " "
fillin ans using "Print the results (y/n)?"
if ans = "y" then
  out pri
  set lines 0
  write .title
  sel all from q$mr$
  out scr
endif
rem q$mr$
goto cleanup
 
*(.................................................)
LABEL Colcomp   *(columns-in-common routine)
out nul
rename col remains to Common
out scr
set var title = ("Columns in common to" & .tbl1 & "and" & .tbl2)
write " "
compute T$$ as count common from r$$ where common in (sel common from q$$)
if T$$ > 0 then
 write .title
 sel common from q$$ where common in (sel common from r$$)
 write .T$$," columns in common"
else
 write " "
 write "NO COLUMNS IN COMMON"
 write " "
endif
write " "
set var ans = "n"
fillin ans using "Print the results (y/n)? "
write " "
if ans = "y" then
  out pri
   set lines 0
   write .title
    sel common from q$$ where common in (sel common from r$$)
  out scr
endif
 
*(----------------------------------------------------------------------)
LABEL cleanup
rem q$$
rem r$$
 
LABEL finish
set mess on
set err mess on
clear VARIABLES ans, title, tbl1, tbl2, t$$
set lines 24
*(restore quote format)
set quotes=null
set quotes=.quotest
clear variables quotest
cls
list
return
 
*(----------------------------------------------------------------------)
LABEL datcomp          *(this is a brute-force data subtraction routine)
write " "              *(that might run pretty slow without indexing)
write "Compare data of two tables"
write "--------------------------"
write " "
 
set var tbl1 text
set var tbl2 text
set var ans = "n"
list
write " "
write "Query: In Table 1, which rows of data are different from Table 2's?"
write "       (i.e. Tbl1 - Tbl2 = rows unique to Tbl1 )"
write " "
fillin tbl1 using "Enter name of table 1: "
fillin tbl2 using "Enter name of table 2: "
write "subtracting..."
 
rem tbl3
subtract &tbl2 from &tbl1 form tbl3
 
write " "
set var title = ("Remnant rows of" & .tbl1 & "after removing" & .tbl2 )
 
compute t$$ as rows from tbl3
set var title = (.title & "-" & ctxt(t$$) & "rows different")
if T$$ > 0 then
 write .title
 write " "
 sel all from tbl3
else
 write " "
 write "NO DIFFERENCE FOUND"
 write " "
endif
 
fillin ans using "Print the results (y/n)? "
if ans = "y" then
  out pri
   set lines 0
   write .title
   sel all from tbl3
   out scr
endif
drop table tbl3
goto Finish
 
 
